#include "ablib.h"
#include "Pathname.h"
#include "IsKanji.h"
#include <vector>

namespace ablib{

Pathname::Pathname(const ablib::string &file){
	std::vector<ablib::string> dirs;
	ablib::string::size_type q = 0;
	ablib::string dir;
#ifdef UNICODE
	for(ablib::string::size_type i = 0 ; i < file.length() ; ++i){
#else
	for(ablib::string::size_type i = 0 ; i < file.length() ; i += ablib::IsKanji(file[i]) ? 2 : 1){
#endif
		if(file[i] == '\\' || file[i] == '/'){
			dir = file.substr(q,i - q);
			q = i + 1;
			if(dir == _T(".") || dir == _T(""))continue;
			else if(dir == _T("..")){if(!dirs.empty())dirs.pop_back();}
			else dirs.push_back(dir);
		}
	}
	dir = file.substr(q);
	if(dir == _T(".") || dir == _T(""));
	else if(dir == _T("..")){if(!dirs.empty())dirs.pop_back();}
	else dirs.push_back(dir);

	if(dirs.size() >= 2)m_dir = dirs[0];
	if(!dirs.empty()){
		for(std::vector<ablib::string>::size_type i = 1 ; i < dirs.size() - 1 ; ++i)m_dir += _T("\\") + dirs[i];
		m_base = dirs[dirs.size() - 1];
	}

	q = m_base.rfind(_T("."));
	if(q != ablib::string::npos){
		m_type = m_base.substr(q);
		m_base.erase(q);
	}
}


}
