#ifndef __ABLIB_LEXICAL_CAST_H__
#define __ABLIB_LEXICAL_CAST_H__

/** std::stringstreamɗ񂾕yȂ񂾂ǁCTCYłȂ肷D
* ̂ŌʎDKvɂȂɑ₵Ă܂傤D
* 
* 
* struct A{};
* template<typename T,typename S> T test(S s){printf("general\n");return T();}
* template<> A test<A>(const A &s){printf("special\n");return s;}
* 
* int main(){
* 	A a;
* 	test<A>(a);
* }
* ̌ʂ"general"
*/

#include "ablib.h"
#include <typeinfo>

namespace ablib{
	struct bad_lexical_cast{
	public:
		bad_lexical_cast() : source(&typeid(void)),target(&typeid(void)){}
		bad_lexical_cast(const std::type_info &s,const std::type_info &t) : source(&s),target(&t){}
		const std::type_info &source_type() const{return *source;}
		const std::type_info &target_type() const{return *target;}
	private:
		const std::type_info *source;
		const std::type_info *target;
	};

	namespace lexical_cast_detail{
		template <typename CH> inline bool Check_Str_ToNumber(const ablib::basic_string<CH> &s){
			for(ablib::string::size_type i = 0 ; i < s.length() ; ++i){
				if(!('0' <= s[i] && s[i] <= '9')){
//					DEBUGSTRING(_T("ablib::lexical_cast : u%sv͐ȊO܂łD"),ablib::TransCode::Ts.c_str());
					return false;
				}
			}
			return true;
		}
		inline bool lexical_cast_impl(int &rv,const ablib::basic_string<char> &s){
			if(!Check_Str_ToNumber<char>(s))return false;
			rv = ::atoi(s.c_str());
			return true;
		}
		inline bool lexical_cast_impl(int &rv,const ablib::basic_string<wchar_t> &s){
			if(!Check_Str_ToNumber<wchar_t>(s))return false;
			rv = ::_wtoi(s.c_str());
			return true;
		}
		inline bool lexical_cast_impl(size_t &rv,const ablib::basic_string<char> &s){
			if(!Check_Str_ToNumber<char>(s))return false;
			rv = static_cast<size_t>(::atoi(s.c_str()));
			return true;
		}
		inline bool lexical_cast_impl(size_t &rv,const ablib::basic_string<wchar_t> &s){
			if(!Check_Str_ToNumber<wchar_t>(s))return false;
			rv = static_cast<size_t>(::_wtoi(s.c_str()));
			return true;
		}
		inline bool lexical_cast_impl(int &rv,char c){
			if('0' <= c && c <= '9'){rv = c - '0';return true;}
			else return false;
		}
		inline bool lexical_cast_impl(int &rv,wchar_t c){
			if('0' <= c && c <= '9'){rv = c - '0';return true;}
			else return false;
		}
		inline bool lexical_cast_impl(ablib::string &rv,int n){
			TCHAR tmp[128];
			::wsprintf(tmp,_T("%d"),n);
			rv = tmp;
			return true;
		}
		inline bool lexical_cast_impl(ablib::string &rv, __int64 n) {
			TCHAR tmp[128];
			::wsprintf(tmp, _T("%d"), n);
			rv = tmp;
			return true;
		}
		inline bool lexical_cast_impl(ablib::string &rv,unsigned int n){
			TCHAR tmp[128];
			::wsprintf(tmp,_T("%lu"),n);
			rv = tmp;
			return true;
		}
		inline bool lexical_cast_impl(ablib::string &rv,unsigned long n){return lexical_cast_impl(rv,(unsigned int)n);}
	}
	template<typename T,typename S> inline T lexical_cast(S s){
		T rv;
		if(!lexical_cast_detail::lexical_cast_impl(rv,s))throw bad_lexical_cast(typeid(T),typeid(S));
		return rv;
	}


}//namespace ablib

#endif //__ABLIB_LEXICAL_CAST_H__


