#include "edit.h"
#include "Command.h"
#include "EditWnd.h"
#include "struct.h"
#include "edit_const.h"

namespace ablib{
namespace window{
namespace edit{

/** }D
*/
Command *InsertCommand::operator()(EditWnd *ed){
	ablib::string oldstr = ed->m_buf.GetText(m_pos.lineno);
	POS pos;
	int oldy = ed->m_buf.POSToXY(m_pos).y;
//	if(m_pos.lineno == ed->m_buf.GetLineCount() - 1)oldy = -1;
//	else oldy = ed->m_buf.POSToXY(m_pos).y;
	bool sita_mukou_sinai = false;
	if(ed->m_buf.GetLayoutLineCount() - 1 == m_pos.lineno)sita_mukou_sinai = true;
	if(!ed->m_buf.InsertText(m_pos,pos,m_str.c_str(),m_sep))return NULL;
	ed->m_pos.SetPos(pos);
	if(ed->GetWindow()){
		ed->escape();
		if(ed->m_isdraw){
			ed->GetWindow()->GetVScrollBar()->SetRange(0,ed->m_buf.GetLayoutLineCount() - 1);
			ed->GetWindow()->GetHScrollBar()->SetRange(0,ed->m_buf.GetMaxLen());
			//ĕ`ʒuvZ
			int newy;
			if(pos.lineno >= ed->m_buf.GetLineCount())newy = -1;
			else newy = ed->m_buf.POSToXY(pos).y;
			if(sita_mukou_sinai || (oldy == newy && oldy != -1 && newy != -1)){
				//͍̕ĕ`̕KvȂD
				ed->Invalidate(m_pos,POS(pos.lineno,::lstrlen(ed->m_buf.GetText(pos.lineno))),oldstr.c_str());
			}else ed->Invalidate(m_pos,POS(-1,-1),oldstr.c_str());

		}
		ed->SetScroll();
		ed->SetCaret(true);
	}
	return new DeleteCommand(m_pos,pos);
}

/** 폜D
*/
Command *DeleteCommand::operator()(EditWnd *ed){
	ed->escape();
	int oldy= ed->m_buf.POSToXY(m_end).y;
//	if(m_end.lineno == ed->m_buf.GetLineCount())oldy = -1;
//	else oldy = ed->m_buf.POSToXY(m_end).y;
	bool sita_mukou_sinai = false;
	if(ed->m_buf.GetLayoutLineCount() - 1 == m_end.lineno)sita_mukou_sinai = true;
	const TCHAR *delstr = ed->m_buf.DeleteText(m_start,m_end);
	if(delstr == NULL)return NULL;
	ed->m_pos.SetPos(m_start);
	if(ed->GetWindow()){
		if(ed->m_isdraw){
			ed->GetWindow()->GetVScrollBar()->SetRange(0,ed->m_buf.GetLayoutLineCount() - 1);
			ed->GetWindow()->GetHScrollBar()->SetRange(0,ed->m_buf.GetMaxLen());
			int newy;
			if(m_start.lineno >= ed->m_buf.GetLineCount())newy = -1;
			else newy = ed->m_buf.POSToXY(m_start).y;
			if(sita_mukou_sinai || (oldy == newy && oldy != -1 && newy != -1)){
				ed->Invalidate(m_start,POS(m_start.lineno,::lstrlen(ed->m_buf.GetText(m_start.lineno))));
			}else ed->Invalidate(m_start,POS(-1,-1));
		}
		ed->SetScroll();
		ed->SetCaret(true);
	}
	return new InsertCommand(m_start,delstr);
}

/** uD
*/
Command *ReplaceCommand::operator()(EditWnd *ed){
	int oldy;
	if(m_end.lineno >= ed->m_buf.GetLineCount() - 1)oldy = -1;
	else oldy = ed->m_buf.LineToY(m_end.lineno + 1);
	const TCHAR *delstr = ed->m_buf.DeleteText(m_start,m_end);
	if(delstr == NULL)return NULL;
	POS pos;
	if(!ed->m_buf.InsertText(m_start,pos,m_str.c_str(),m_sep))return NULL;
	ed->m_pos.SetPos(pos);
	if(ed->GetWindow()){
		ed->escape();
		if(ed->m_isdraw){
			ed->GetWindow()->GetVScrollBar()->SetRange(0,ed->m_buf.GetLayoutLineCount() - 1);
			ed->GetWindow()->GetHScrollBar()->SetRange(0,ed->m_buf.GetMaxLen());
			int newy;
			if(pos.lineno >= ed->m_buf.GetLineCount() - 1)newy = -1;
			else oldy = ed->m_buf.LineToY(pos.lineno + 1);
			if(oldy == newy && oldy != -1 && newy != -1){
				ed->Invalidate(m_start,POS(m_start.lineno,::lstrlen(ed->m_buf.GetText(m_start.lineno))));
			}else ed->Invalidate(m_start,POS(-1,-1));
		}
		ed->SetScroll();
		ed->SetCaret(true);
	}
	return new ReplaceCommand(m_start,pos,delstr);
}

}//namespace edit
}//namespace window
}//namespace ablib