#include "edit.h"
#include "editbuf.h"
#include "struct.h"
#include "../ablib/KRSearch.h"

namespace ablib{
namespace window{
namespace edit{

/** w肳ꂽʒuɕ}D
* @param pos }ʒuD
* @param endpos }̈ʒuԂobt@D
* @param str }镶D
* @param sep sR[h
* @return trueCsfalseD
*/
bool EditBuf::InsertText(POS pos,POS &endpos,const TCHAR *str,const TCHAR *sep){
	if(!m_memory.InsertText(pos,endpos,str,sep))return false;
	if(m_dolayout)m_layout.DoLayout(pos.lineno,pos.lineno + 1,endpos.lineno + 1);
	return true;
}

/** w肳ꂽ͈͂̕폜D
* @param start 폜Jnʒu
* @param end 폜Iʒu
* @param sep sR[h
* @return 폜DsNULLD
*/
const TCHAR *EditBuf::DeleteText(POS start,POS end,const TCHAR *sep){
	const TCHAR *rv = m_memory.DeleteText(start,end,sep);
	if(m_dolayout)m_layout.DoLayout(start.lineno,end.lineno + 1,start.lineno + 1);
	return rv;
}

/** CAEg̍siu[vIvȍsjԂD
*/
int EditBuf::GetLayoutLineCount() const{
	if(m_dolayout)return m_layout.GetLayoutLineCount();
	else return m_memory.GetLineCount();
}

/** [ԍ폜
*/
void EditBuf::RemoveAll(){
	if(m_dolayout){
		int oldline = m_memory.GetLineCount();
		m_memory.RemoveAll();
		m_layout.DoLayout(0,oldline);
	}else m_memory.RemoveAll();
}

/** XYWPOSW֕ϊDtab̈ʒuvZD
* @param xy ɂXYWD
* @return vZ
*/
POS EditBuf::XYToPOS(XY xy){
	if(m_dolayout)return m_layout.XYToPOS(xy);
	else{
		if(xy.y <0 || xy.y >= m_memory.GetLineCount())return POS(-1,-1);
		const TCHAR *str = m_memory.GetText(xy.y);
		int tabs = 0;
		const TCHAR *p = str;
		while(p = ablib::KRSearch::strstr(p,_T("\t"))){
			int add = tabs + (p - str) + 1;
			if(add >= xy.x)break;
			for(; add % m_tabsize ; ++add);
			if(add - 1 > xy.x){
				xy.x = tabs + p - str;
				break;
			}
			tabs = add - (p - str) - 1;
			++p;
		}
		return POS(xy.y,xy.x - tabs);
	}
}

/** POSWXYW֕ϊDtab̈ʒuvZD
* @param pos ɂPOSWD
* @return vZ
*/
XY EditBuf::POSToXY(POS pos){
	if(m_dolayout)return m_layout.POSToXY(pos);
	else{
		if(pos.lineno < 0 || pos.lineno >= m_memory.GetLineCount())return XY(-1,-1);
		const TCHAR *str = m_memory.GetText(pos.lineno);
		return XY(GetXLen(str,pos.column),pos.lineno);
	}
}

/** ws̃CAEg̃f[^擾D
* @param y 擾s
* @return ysڂ̃CAEgf[^
*/
LayoutData EditBuf::GetLayoutData(int y){
	if(m_dolayout)return m_layout.GetLayoutData(y);
	else{
		LayoutData rv;
		rv.line = y;
		rv.offset = 0;
		rv.length = ::lstrlen(m_memory.GetText(y));
		return rv;
	}
}

/** CAEgsǂD
* @param d sȂtrueCsȂȂfalseD
*/
void EditBuf::SetDoLayout(bool d){
	if(m_dolayout == d)return;
	m_dolayout = d;
	if(d){m_layout.Clear();m_layout.DoLayout(0,0);}
}

/** ĕ`悷ׂʒuvZDnCCgȂǂƑȂ\邽߁D
* @param start Kĕ`悷ʒu̍ŏD
* @param end Kĕ`悷ʒu̍ŌD
* @param oldstr ɑOstart.linenos̕Ƃ^ʖڂɌvZD
*/
void EditBuf::CalcInvalidateRect(POS &start,POS &end,const TCHAR *oldstr){
	if(oldstr){
		SmallVector<PosLen> oldresult,newresult;
		const TCHAR *str = m_memory.GetText(start.lineno);
		if(::lstrcmp(oldstr,str) == 0)return;
		for(int i = 0 ; i < m_hilight.GetHilightNum() ; ++i){
			const TCHAR *p = str;
			const TCHAR *newstr = p;
			while(true){
				bool old = m_hilight.Match(newstr,i,oldresult);
				bool New = m_hilight.Match(oldstr,i,newresult);
				if(!old && !New)break;
				if(!old || !New || oldresult[0].pos != newresult[0].pos || oldresult[0].len != newresult[0].len){
					start.column = Min(start.column,p - newstr);
					break;
				}
				p += newresult[0].pos + newresult[0].len;
				if(p - newstr > start.column)break;
			}
		}
	}else{
		if(m_hilight.GetHilightNum() != 0)start.column = 0;
		end = POS(-1,-1);
	}
}

/** Ps̒̕ԂD
* @param y ׂsD
* @return ysڂ̒̕D
*/
int EditBuf::GetLineLen(int y){
	const TCHAR *str;
	int len;
	if(m_dolayout){
		LayoutData ld = m_layout.GetLayoutData(y);
		str = m_memory.GetText(ld.line) + ld.offset;
		len = ld.length;
	}else{
		str = m_memory.GetText(y);
		len = ::lstrlen(str);
	}
	return GetXLen(str,len);
}

/** tablĒvZƂǂȂ邩߂D
* @param str ƂȂ镶D
* @param len str̓len𑊎ɂD
* @return vZ
*/
int EditBuf::GetXLen(const TCHAR *str,int len){
	int tabs = 0;
	const TCHAR *p = str;
	while(p = ablib::KRSearch::strstr(p,_T("\t"))){
		if(p - str >= len)break;
		int add = tabs + (p - str) + 1;
		for(; add % m_tabsize ; ++add);
		tabs = add - (p - str) - 1;
		++p;
	}
	return len + tabs;
}


}//namespace edit
}//namespace window
}//namespace ablib

