#ifndef __ABLIB_WINDOW_EDIT_EDITBUF_H__
#define __ABLIB_WINDOW_EDIT_EDITBUF_H__

#include "memory.h"
#include "layout.h"
#include "hilight.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{
namespace edit{

/**
* obt@ǗCCAEgCFƂꊇǗD
* {Iɂ͕KvȎɉʂɎw߂ô݁D
*/
class EditBuf
{
public:
	EditBuf() : m_layout(&m_memory),m_hilight(&m_memory),m_tabsize(1),m_dolayout(false){};
	~EditBuf(){};

public:
	//
	void SetTabSize(int tab){m_memory.SetTabSize(tab);m_layout.SetTabSize(tab);m_tabsize = tab;}

private:
	int m_tabsize;
	int GetXLen(const TCHAR *str,int len);//str̓lenʏ̒ɕϊ

//obt@Ǘ
public:
	int GetLineCount() const{return m_memory.GetLineCount();}
	const TCHAR *GetText(int line){return m_memory.GetText(line);}
	const TCHAR *GetText(POS start,POS end,const TCHAR *sep = _T("\n")){return m_memory.GetText(start,end,sep);}
	bool InsertText(POS pos,POS &endpos,const TCHAR *str,const TCHAR *sep = _T("\n"));
	const TCHAR *DeleteText(POS start,POS end,const TCHAR *sep = _T("\n"));
	void RemoveAll();

private:
	Memory m_memory;

//CAEgǗ
public:
	LayoutData GetLayoutData(int y);
	int GetLayoutLineCount() const;
	int GetLineLen(int y);
	int LineToY(int line) const{return (m_dolayout ? m_layout.LineToY(line) : line);}
	int YToLine(int y) const{return (m_dolayout ? m_layout.YToLine(y) : y);}

	POS XYToPOS(XY xy);
	XY POSToXY(POS pos);

	void SetMaxX(int x){m_layout.SetMaxX(x);}
	int GetMaxLen() const{return (m_dolayout ? m_layout.GetMaxLength() : m_memory.GetMaxLength());}

	void SetDoLayout(bool d);

private:
	Layout m_layout;
	bool m_dolayout;

//F
public:
	bool AddHilight(const TCHAR *word,int opt,int hpos){return m_hilight.AddHilightData(word,opt,hpos);}
	void HilightClear(){m_hilight.Clear();}
	
	bool HilightMatch(const TCHAR *str,int i,SmallVector<PosLen> &result){return m_hilight.Match(str,i,result);}

	//ɂׂ͈͂̌vZD
	void CalcInvalidateRect(POS &start,POS &end,const TCHAR *oldtopstr = NULL);

private:
	Hilight m_hilight;

};

}//namespace edit
}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_EDIT_EDITBUF_H__

