#ifndef __ABLIB_WINDOW_EDIT_EDITPOS_H__
#define __ABLIB_WINDOW_EDIT_EDITPOS_H__

#include "EditBuf.h"

namespace ablib{
namespace window{
namespace edit{

/** ʒuǗDIʒuDcaret̕`͂Ȃ悤ɂĂ݂܂D
* 2BYTËʒuDtab͂ȂD
*/
class EditPos{
public:
	EditPos(EditBuf *buf) : m_selecting(false),m_beginsel(false),m_pos(POS(0,0)),m_rx(0),
		m_xy(XY(0,0)),m_buf(buf),m_seltop(POS(0,0)),m_selend(POS(0,0)),m_startsel(POS(0,0)){}
	~EditPos(){}
	POS GetPos() const{return m_pos;}
	XY GetXY() const{return m_xy;}

	bool SetPos(POS pos);

	void BeginSel(POS begin);
	void BeginSel(){BeginSel(m_pos);}
	void EndSel(POS end);
	void EndSel(){EndSel(m_pos);}
	void SetSel(POS start,POS end);
	void Escape(){m_beginsel = m_selecting = false;}
	bool IsSelecting() const{return m_selecting;}
	bool IsBeginSel() const{return m_beginsel;}
	POS SelTop() const{return m_seltop;}
	POS SelEnd() const{return m_selend;}

	bool Up(int n = 1);
	bool Down(int n = 1);
	bool Left(int n = 1);
	bool Right(int n = 1);

	void CorrectXY(XY &xy);


private:
	bool CheckPos(POS &pos);
	POS m_pos,m_seltop,m_selend,m_startsel;
	XY m_xy;
	int m_rx;
	bool m_selecting,m_beginsel;
	
	EditBuf *m_buf;
	
	NOCOPY(EditPos);
};

}//namespace edit
}//namespace window
}//namespace ablib


#endif //__ABLIB_WINDOW_EDIT_EDITPOS_H__

