#include "edit.h"
#include "../window/window.h"
#include "editwnd.h"
#include "editbuf.h"
#include "edit_const.h"
#include "../ablib/SmallVector.h"
#include "../ablib/KRSearch.h"

/* ` */

namespace ablib{
namespace window{

using namespace edit;

namespace{
	/** ^ꂽtab̃f[^val̈ʒutabl̂ɕϊD
	* @param tabdata ^ũf[^DPosLen = (pos,len)̔zŁCʒuposɒlentabĂD
	* @param val ̈ʒuD
	* @return vZʁD
	*/
	int GetTabToSpLen(SmallVector<EditWnd::TabData> &tabdata,int val){
		int tabs = 0;
		for(int i = 0 ; i < tabdata.size() ; ++i){
			if(tabdata[i].pos >= val)break;
			tabs += tabdata[i].tabs;
		}
		return val + tabs;
	}
}

/** `DWM_PAINTD
*/
bool EditWnd::OnPaint(Window *wnd){
	Graphic g(wnd);
	if(!m_isdraw)return true;

	//SwiFœhԂD
	wnd->SetFillColor(m_config.NormalBackColor.normal);
	g.SetUpdate();
	g.FillRect(g.GetPaintRect());

	//`Jnʒȕ
	int starty = wnd->GetVScrollBar()->GetPos() + (g.GetPaintRect().top - TOP_SPACE) / TextHeight();
	if(starty >= m_buf.GetLayoutLineCount())starty = m_buf.GetLayoutLineCount() - 1;
	else if(starty <= 0)starty = 0;
	int startline = m_buf.YToLine(starty);
	int endy = wnd->GetVScrollBar()->GetPos() + (g.GetPaintRect().bottom + TOP_SPACE) / TextHeight();
	if(m_buf.GetLayoutLineCount() <= endy)endy = m_buf.GetLayoutLineCount() - 1;
	else if(endy <= 0)endy = 0;
	int endline = m_buf.YToLine(endy);
	//`Jn
	SmallVector<int> offsets;
	SmallVector<TabData> tabdata;
	SmallVector<PosLen> hdata;
	ablib::string outstr;
	for(int line = startline ; line <= endline ; ++line){
		//擾
		const TCHAR *str = m_buf.GetText(line);
		if(str == NULL)break;
		int len = ::lstrlen(str);

		//܂̓ItZbgW߂
		offsets.clear();
		int y = m_buf.LineToY(line);
		int lasty;
		if(line == m_buf.GetLineCount() - 1)lasty = m_buf.GetLayoutLineCount();
		else lasty = m_buf.LineToY(line + 1);
		for(int j = y ; j < lasty ; ++j)offsets.push_back(m_buf.GetLayoutData(j).offset);

		//'\t'̈ʒu̎擾D
		//܂'\t'' 'ɕϊʂoutstrɓD
//		tabdata.erase(tabdata.begin(),tabdata.end());
		tabdata.clear();
		const TCHAR *p,*q;
		q = str;
		int drawlen = 0,tabs = 0;
		outstr = _T("");
		outstr.reserve(::lstrlen(str) + 10);
		while(p = ablib::KRSearch::strstr(q,_T("\t"))){
			outstr.append(q,p - q);
			int add = tabs + p - str + 1;
			for(; add % m_config.tabsize ; ++add)outstr += _T(" ");
			outstr += _T(" ");
			tabdata.push_back(TabData(p - str,add - tabs - (p - str) - 1));
			tabs = add - (p - str) - 1;
			q = p + 1;
		}
		outstr += q;
		p = outstr.c_str();

		//'\t'lăItZbgD
		for(int i = 0 ; i < offsets.size() ; ++i)offsets[i] = GetTabToSpLen(tabdata,offsets[i]);

		//I͈
		int seltop,selend;
		if(selecting()){
			if(line > m_pos.SelTop().lineno)seltop = 0;
			else if(line == m_pos.SelTop().lineno)seltop = m_pos.SelTop().column;
			else seltop = len;
			if(line > m_pos.SelEnd().lineno)selend = 0;
			else if(line == m_pos.SelEnd().lineno)selend = m_pos.SelEnd().column;
			else selend = len;
		}else{seltop = 0;selend = 0;}

		seltop = GetTabToSpLen(tabdata,seltop);
		selend = GetTabToSpLen(tabdata,selend);

		//SI̎͂`ďI
		if(seltop == 0 && selend == len){
			wnd->SetTextColor(m_config.SelectColor.normal,m_config.SelectBackColor.normal);
			g.SetUpdate();
			DrawLine(wnd,g,line,outstr,offsets,0,outstr.length());

			LayoutData ld = m_buf.GetLayoutData(lasty - 1);
			int endx = GetTabToSpLen(tabdata,ld.length + ld.offset) - GetTabToSpLen(tabdata,ld.offset);
			bool sel = false;
			if(selecting() && m_pos.SelTop().lineno <= line && line < m_pos.SelEnd().lineno)sel = true;
			DrawLineEnd(wnd,g,endx,lasty - 1,sel);
			continue;
		}

		//Ƃ肠ʂɕ`
		wnd->SetTextColor(m_config.NormalColor.normal,m_config.NormalBackColor.normal);
		g.SetUpdate();
		DrawLine(wnd,g,line,outstr,offsets,0,outstr.length());

		//\Xƕ`
		for(int i = 0 ; i < m_hilightcolor.size() ; ++i){
			wnd->SetTextColor(m_hilightcolor[i].text,m_hilightcolor[i].back);
			g.SetUpdate();
			p = str;
			while(m_buf.HilightMatch(p,i,hdata)){
				int fromstr = p - str;
				p += hdata[0].pos + hdata[0].len;
				for(int j = 1 ; j < hdata.size() ; ++j){
					int pos = GetTabToSpLen(tabdata,hdata[j].pos + fromstr);
					int end = GetTabToSpLen(tabdata,hdata[j].pos + fromstr + hdata[j].len);
					DrawLine(wnd,g,line,outstr,offsets,pos,end);
				}
			}
		}

		//ŌɑI͈͂`
		wnd->SetTextColor(m_config.SelectColor.normal,m_config.SelectBackColor.normal);
		g.SetUpdate();
		DrawLine(wnd,g,line,outstr,offsets,seltop,selend);

		LayoutData ld = m_buf.GetLayoutData(lasty - 1);
		int endx = GetTabToSpLen(tabdata,ld.length + ld.offset) - GetTabToSpLen(tabdata,ld.offset);
		bool sel = false;
		if(selecting() && m_pos.SelTop().lineno <= line && line < m_pos.SelEnd().lineno)sel = true;
		DrawLineEnd(wnd,g,endx,lasty - 1,sel);
	}
	return true;
}

/** _s1s`Dtab̍l͍sȂ̂ŗ\ߒĂKvD
* @param wnd `EBhE
* @param g OtBbNIuWFNg
* @param line sڂ`
* @param str `D
* @param offsets offsetȂzD
* @param start ŏ̈ʒu
* @param end Ō̈ʒu
*/
void EditWnd::DrawLine(Window *wnd,Graphic &g,int line,ablib::string &str,SmallVector<int> &offsets,int start,int end){
//	end = Min(end,static_cast<int>(str.length()));
//	DEBUGSTRING(_T("ablib::window::EditWnd::DrawLine : u%sv"),str.c_str());
	int drawy = (m_buf.LineToY(line) - wnd->GetVScrollBar()->GetPos()) * TextHeight() + TOP_SPACE;
	int offset = 0;
	bool draw = false;
	int drawleftx = wnd->GetHScrollBar()->GetPos();
	int textwidth = m_fontdata.avewidth;
	for(int i = 0 ; i < offsets.size() - 1; ++i,drawy += TextHeight()){
		if(drawy <= 0)continue;
		if(start <= offsets[i + 1] && offsets[i] <= end){
			int st = Max(start,offsets[i]);
			int en = Min(offsets[i + 1],end);
			g.WriteText(Point((st - offsets[i] - drawleftx) * textwidth + LEFT_SPACE,drawy),str.c_str() + st,en - st);
//			ablib::string deb(str.c_str() + st,en - st);
//			DEBUGSTRING(_T("ablib::window::EditWnd::DrawLine : (%d,%d)Ɂu%svóD"),
//				(st - offsets[i] - drawleftx) * textwidth + LEFT_SPACE,drawy,deb.c_str());
		}
	}
	if(offsets[offsets.size() - 1] <= end){
		int st = Max(start,offsets[offsets.size() - 1]);
		g.WriteText(Point((st - offsets[offsets.size() - 1] - drawleftx) * textwidth + LEFT_SPACE,drawy),str.c_str() + st,end - st);
//		ablib::string deb(str.c_str() + st,end - st);
//		DEBUGSTRING(_T("ablib::window::EditWnd::DrawLine : (%d,%d)Ɂu%svóD"),
//			(st - offsets[offsets.size() - 1] - drawleftx) * textwidth + LEFT_SPACE,drawy,deb.c_str());
	}
}

/**
s̍Ō݂܂Ds[EOF]D
* @param wnd EBhEnh
* @param g OtBbNIuWFNg
* @param endx `XWD
* @param endy `YWD
* @param sel IĂ邩ǂD
*/
void EditWnd::DrawLineEnd(Window *wnd,Graphic &g,int endx,int endy,bool sel){
	LayoutData ld = m_buf.GetLayoutData(endy);
	int line = m_buf.YToLine(endy);
	int drawx = LEFT_SPACE + (endx - wnd->GetHScrollBar()->GetPos()) * m_fontdata.avewidth;
	int drawy = (endy - wnd->GetVScrollBar()->GetPos()) * TextHeight() + TOP_SPACE;
	if(line == m_buf.GetLineCount() - 1){//EOF
		wnd->SetTextColor(m_config.NormalColor.eof,m_config.NormalBackColor.eof);
		g.SetUpdate();
		g.WriteText(Point(drawx,drawy),_T("[EOF]"));
	}else{
		if(sel)wnd->SetLineStyle(m_config.SelectColor.Return,1,Window::ps_solid);
		else wnd->SetLineStyle(m_config.NormalColor.Return,1,Window::ps_solid);
		if(sel)wnd->SetFillColor(m_config.SelectBackColor.Return);
		else wnd->SetFillColor(m_config.NormalBackColor.Return);
		g.SetUpdate();
		Rect rc;
		rc.left = drawx;
		rc.right = rc.left + m_fontdata.avewidth;
		rc.top = drawy;
		rc.bottom = rc.top + TextHeight();
		g.FillRect(rc);

		g.DrawLine(
			Point(drawx + m_fontdata.avewidth / 4,drawy + 2 * TextHeight() / 3),
			Point(drawx + m_fontdata.avewidth / 2,drawy + 4 * TextHeight() / 5));
		g.DrawLine(
			Point(drawx + m_fontdata.avewidth / 2,drawy + 4 * TextHeight() / 5),
			Point(drawx + m_fontdata.avewidth / 2,drawy + 1 * TextHeight() / 5));
		g.DrawLine(
			Point(drawx + 3 * m_fontdata.avewidth / 4,drawy + 2 * TextHeight() / 3),
			Point(drawx + m_fontdata.avewidth / 2,drawy + 4 * TextHeight() / 5));
	}
}

/** ^ꂽlɏ]ė̈𖳌D
* @param start ̈̊Jnꏊ
* @param end ̈̏Iꏊ
* @param oldtopstr start.linenöʒu̕ҏWO̕nĂƁCXɐ^ʖڂɌvZĂD
*/
void EditWnd::Invalidate(POS start,POS end,const TCHAR *oldtopstr){
	if(!GetWindow())return;
	bool bottomlimit = true;
	m_buf.CalcInvalidateRect(start,end,oldtopstr);

	if(end == POS(-1,-1)){
		//̂Ƃ͈ԉ܂ŖɂD
		end.lineno = m_buf.GetLineCount() - 1;
		end.column = ::lstrlen(m_buf.GetText(end.lineno));
		bottomlimit = false;
	}

	XY startxy = m_buf.POSToXY(start);
	XY endxy = m_buf.POSToXY(end);

	if(startxy.x == 0 && startxy.y > 0){
		--startxy.y;
		startxy.x = m_buf.GetLineLen(startxy.y);
	}

	//Ōオs܂ł͉̎sEOFɂ邽ߒ
	if(end.column == ::lstrlen(m_buf.GetText(end.lineno))){
		if(end.column == m_buf.GetLineCount() - 1)++endxy.x;//s
		else endxy.x+= 5;//[EOF]
	}
	Rect rc;
	int textwidth = m_fontdata.avewidth;
	if(startxy.y == endxy.y && bottomlimit){
		rc = GetWindow()->GetClientRect();
		//startends͈̎ŝݖɂD
		rc.top = (startxy.y - GetWindow()->GetVScrollBar()->GetPos()) * TextHeight() + TOP_SPACE;
		rc.bottom = rc.top + TextHeight();
		rc.left = (startxy.x - GetWindow()->GetHScrollBar()->GetPos()) * textwidth + LEFT_SPACE;
		rc.right = (endxy.x - GetWindow()->GetHScrollBar()->GetPos()) * textwidth + LEFT_SPACE;
		GetWindow()->Invalidate(rc);
	}else{
		//łȂƂ͎OiKɂ킯ĖɂD
		//܂͈ԏ
		rc = GetWindow()->GetClientRect();
		rc.top = (startxy.y - GetWindow()->GetVScrollBar()->GetPos()) * TextHeight() + TOP_SPACE;
		rc.bottom = rc.top + TextHeight();
		rc.left = (startxy.x - GetWindow()->GetHScrollBar()->GetPos()) * textwidth + LEFT_SPACE;
		GetWindow()->Invalidate(rc);
		//Đ^
		if(bottomlimit){
			//ɌE鎞
			rc.top = rc.bottom;
			rc.left = 0;
			rc.bottom = (endxy.y - GetWindow()->GetVScrollBar()->GetPos()) * TextHeight() + TOP_SPACE;
			if(startxy.y + 1 != endxy.y)GetWindow()->Invalidate(rc);
			//ŌɈԉ
			rc.top = rc.bottom;
			rc.bottom += TextHeight();
//			rc.right = (endxy.x - m_scroll.GetHBarPos()) * TextHeight() + LEFT_SPACE;
			GetWindow()->Invalidate(rc);
		}else{
			//ԉ܂
			rc = GetWindow()->GetClientRect();
			rc.top =  (startxy.y - GetWindow()->GetVScrollBar()->GetPos() + 1) * TextHeight() + TOP_SPACE;
			GetWindow()->Invalidate(rc);
		}
	}
}


}//namespace window
}//namespace ablib

