#include "edit.h"
#include "EditWnd.h"
#include "command.h"
#include "AskDlg.h"
#include "../ablib/IsKanji.h"

namespace ablib{
namespace window{

using namespace edit;

/*
OC^[tF[X̎D
*/

ablib::string tmp_string;

//֐
const TCHAR *EditWnd::gettext(int x1,int y1,int x2,int y2){
	tmp_string = m_buf.GetText(m_buf.XYToPOS(XY(x1,y1)),m_buf.XYToPOS(XY(x2,y2)));
	return tmp_string.c_str();
}

//J[\ړn
bool EditWnd::gofileend(){
	const TCHAR *text = m_buf.GetText(m_buf.GetLineCount() - 1);
	if(text == NULL)return false;
	POS oldtop = m_pos.SelTop();
	POS oldend = m_pos.SelEnd();
	if(m_pos.SetPos(POS(m_buf.GetLineCount() - 1,::lstrlen(text)))){
		InvalidateSel(oldtop,oldend);
		SetCaret(true);
		return true;
	}else return false;
}

bool EditWnd::golineend(){
	LayoutData ld = m_buf.GetLayoutData(m_pos.GetXY().y);
	int llen = linelen2();
	bool b = moveto(ld.length,m_pos.GetXY().y);
	if(llen != ld.length + ld.offset)return left();
	else return b;
}

bool EditWnd::golineend2(){
	const TCHAR *text = m_buf.GetText(m_pos.GetPos().lineno);
	if(text == NULL)return false;
	bool rv = m_pos.SetPos(POS(m_pos.GetPos().lineno,::lstrlen(text)));
	SetCaret(true);
	return rv;
}

//}n
bool EditWnd::insert(const ablib::string &str,const TCHAR *sep){
//	if(m_set.readonly)return false;
	if(str == _T(""))return true;//false̕ǂH
	if(selecting() && m_pos.SelTop() != m_pos.SelEnd()){
		if(!Delete())return false;
		bool rv = insert(str,sep);
		return rv;
	}else{
		if(selecting())escape();
		InsertCommand cmd(m_pos.GetPos(),str,sep);
		Command *result = cmd(this);
		if(result){m_undo.AddUndoHist(result);return true;}
		else return false;
	}
}

//Sł͂Ȃ
bool EditWnd::overwrite(const ablib::string &str){
//	if(m_set.readonly)return false;
	if(str == _T(""))return true;
	if(selecting() && m_pos.SelTop() != m_pos.SelEnd()){
		if(!Delete())return false;
		bool rv = insert(str);
		return rv;
	}else{
		escape();
		POS end;
		const TCHAR *text = m_buf.GetText(m_pos.GetPos().lineno);
		if(text == NULL)return false;
		Command *result;
		if(m_pos.GetPos().column == ::lstrlen(text)){
			InsertCommand cmd(m_pos.GetPos(),str);
			result = cmd(this);
		}else{
			end.lineno = m_pos.GetPos().lineno;
			end.column = m_pos.GetPos().column + 1;
			ReplaceCommand cmd(m_pos.GetPos(),end,str);
			result = cmd(this);
		}
		if(result){m_undo.AddUndoHist(result);return true;}
		else return false;
	}
}

bool EditWnd::tab(){
	if(selecting()){
		POS seltop = m_pos.SelTop();
		POS selend = m_pos.SelEnd();
		escape();
		for(int i = selend.lineno ; i >= seltop.lineno ; --i){
			const TCHAR *text = m_buf.GetText(i);
			if(text == NULL)break;
			if(text[0] == '\0')break;
			InsertCommand cmd(POS(i,0),_T("\t"));
			Command *result = cmd(this);
			if(result)m_undo.AddUndoHist(result);
			else return false;
		}
		const TCHAR *str = m_buf.GetText(selend.lineno);
		m_pos.SetSel(POS(selend.lineno,::lstrlen(str)),POS(seltop.lineno,0));
		return true;
	}else return insert(_T("\t"));
}

//J[\ړn
bool EditWnd::movetolineno(int column,int lineno){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.SetPos(edit::POS(lineno - 1,column - 1));
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.SetPos(edit::POS(lineno - 1,column - 1));
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::moveto(int x,int y){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.SetPos(m_buf.XYToPOS(edit::XY(x,y)));
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.SetPos(m_buf.XYToPOS(edit::XY(x,y)));
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::down(int n){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.Down(n);
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.Down(n);
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::left(int n){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.Left(n);
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.Left(n);
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::up(int n){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.Up(n);
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.Up(n);
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::right(int n){
	bool rv;
	if(selecting()){
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		rv = m_pos.Right(n);
		InvalidateSel(oldtop,oldend);
	}else rv = m_pos.Right(n);
	SetScroll();
	SetCaret(true);
	return rv;
}

bool EditWnd::nextpage(){
	int pos = GetWindow()->GetVScrollBar()->GetPos();
	int page = GetWindow()->GetVScrollBar()->GetPage();
	if(m_isdraw){
		GetWindow()->GetVScrollBar()->SetPos(pos + page);
		GetWindow()->ScrollWindow(0,page * TextHeight());
	}
	if(down(page)){
		SetCaret(true);
		return true;
	}else return false;
}

bool EditWnd::prevpage(){
	int pos = GetWindow()->GetVScrollBar()->GetPos();
	int page = GetWindow()->GetVScrollBar()->GetPage();
	if(m_isdraw){
		GetWindow()->GetVScrollBar()->SetPos(pos - page);
		GetWindow()->ScrollWindow(0,- page * TextHeight());
	}
	if(up(page)){
		SetCaret(true);
		return true;
	}else return false;
}

//Nbv{[hn
bool EditWnd::copy(){
	if(!selecting())return false;
	const TCHAR *text = m_buf.GetText(m_pos.SelTop(),m_pos.SelEnd(),_T("\r\n"));
	ClipBoard clip(GetWindow());
	if(!clip.IsOpen())return false;
	if(clip.SetText(text)){escape();return true;}
	else return false;
}

bool EditWnd::cut(){
	if(!copy())return false;
	DeleteCommand cmd(m_pos.SelTop(),m_pos.SelEnd());
	Command *result = cmd(this);
	if(!result)return false;
	m_undo.AddUndoHist(result);
	return true;
}

bool EditWnd::paste(){
	ablib::string text;
	ClipBoard clip(GetWindow());
	if(!clip.IsOpen())return false;
	if(clip.GetText(text))return insert(text,_T("\r\n"));
	else return false;
}

//폜n
bool EditWnd::Delete(){
	if(selecting()){
		DeleteCommand cmd(m_pos.SelTop(),m_pos.SelEnd());
		Command *result = cmd(this);
		if(result){m_undo.AddUndoHist(result);return true;}
		else return false;
	}else{
		//̈ꕶ܂ł폜
		POS start = m_pos.GetPos();
		right();
		DeleteCommand cmd(start,m_pos.GetPos());
		Command *result = cmd(this);
		if(result){m_undo.AddUndoHist(result);return true;}
		else return false;
	}
}

bool EditWnd::backspace(){
	if(selecting())return Delete();
	else if(left())return Delete();
	else return false;
}

//n
bool EditWnd::searchdown(const ablib::string &search,const ablib::string &flag){
	setsearch(search,flag);
	if((m_search.SearchOption() & inselect) && selecting())m_search.SetRange(m_pos.SelTop(),m_pos.SelEnd());
	else m_search.SetRange(m_pos.GetPos(),POS(-1,-1));
	return finddown();
}

bool EditWnd::searchup(const ablib::string &search,const ablib::string &flag){
	setsearch(search,flag);
	if((m_search.SearchOption() & inselect) && selecting())m_search.SetRange(m_pos.SelTop(),m_pos.SelEnd());
	else m_search.SetRange(POS(0,0),m_pos.GetPos());
	return findup();
}

bool EditWnd::replacedown(const ablib::string &search,const ablib::string &rep,const ablib::string &flag){
	setsearch(search,flag + _T(",replace"));
	m_replacestr = rep;
	if((m_search.SearchOption() & inselect) && selecting())m_search.SetRange(m_pos.SelTop(),m_pos.SelEnd());
	else m_search.SetRange(m_pos.GetPos(),POS(-1,-1));
	return finddown();
}

bool EditWnd::replaceup(const ablib::string &search,const ablib::string &rep,const ablib::string &flag){
	setsearch(search,flag + _T(",replace"));
	m_replacestr = rep;
	if((m_search.SearchOption() & inselect) && selecting())m_search.SetRange(m_pos.SelTop(),m_pos.SelEnd());
	else m_search.SetRange(POS(0,0),m_pos.GetPos());
	return findup();
}

int EditWnd::replaceall(const ablib::string &search,const ablib::string &rep,const ablib::string &flag,bool up){
	if(m_set.readonly)return false;
	m_search.SetSearch(search,flag + _T(",replace"));
	m_replacestr = rep;
	POS seltop = m_pos.SelTop(),selend = m_pos.SelEnd();
	if(up){
		gofileend();
		if(m_search.SearchOption() & inselect)m_search.SetRange(seltop,selend);
		else m_search.SetRange(POS(0,0),m_pos.GetPos());
		if(!findup())return -1;
		int rv = 1;
		if(m_search.SearchOption() & inselect)m_search.SetRange(seltop,m_pos.GetPos());
		else m_search.SetRange(POS(0,0),m_pos.GetPos());
		while(findup()){
			if(m_search.SearchOption() & inselect)m_search.SetRange(seltop,m_pos.GetPos());
			else m_search.SetRange(POS(0,0),m_pos.GetPos());
			++rv;
		}
		return rv;
	}else{
		gofiletop();
		if(m_search.SearchOption() & inselect)m_search.SetRange(selend,seltop);
		else m_search.SetRange(m_pos.GetPos(),POS(-1,-1));
		if(!finddown())return -1;
		int rv = 1;
		if(m_search.SearchOption() & inselect)m_search.SetRange(m_pos.GetPos(),selend);
		else m_search.SetRange(m_pos.GetPos(),POS(-1,-1));
		while(finddown()){
			if(m_search.SearchOption() & inselect)m_search.SetRange(m_pos.GetPos(),selend);
			else m_search.SetRange(m_pos.GetPos(),POS(-1,-1));
			++rv;
		}
		return rv;
	}
}

bool EditWnd::finddown(){
	if(m_set.readonly)return false;
	POS result;
	int len = m_search.FindDown(result);
	escape();
	if(len == -1)return false;
	POS oldpos = m_pos.GetPos();
	POS start = result;
	POS end = result;
	POS oldselst = m_pos.SelTop();
	POS oldselen = m_pos.SelEnd();
	end.column += len;
	ablib::string r = m_search.GetReplaceStr(m_replacestr);
	m_pos.SetPos(start);
	SetCaret(true);
	m_pos.SetSel(start,end);
	InvalidateSel(oldselst,oldselen);
	if(m_search.SearchOption() & replace){
		if(m_search.SearchOption() & ask){
			AskDlg ask;
			int a = ask.Ask(m_appint,GetWindow());
			if(a == AskDlg::replace || a == AskDlg::replacenext || a == AskDlg::all){
				DeleteCommand del(result,end);
				Command *re = del(this);
				if(re == NULL)return false;
				m_undo.AddUndoHist(re);
				InsertCommand ins(result,r);
				re = ins(this);
				if(re == NULL)return false;
				else m_undo.AddUndoHist(re);
				if(a == AskDlg::replacenext)return finddown();
				else if(a == AskDlg::all){
					ablib::string fl = m_search.SearchOptionStr();
					fl.erase(fl.find(_T("ask")),3);
					if(replaceall(m_search.SearchBuffer(),m_replacestr,fl) != -1)return true;
					else return false;
				}else return true;
			}else if(a == AskDlg::searchdown){
				m_pos.SetPos(end);
				return finddown();
			}else if(a == AskDlg::searchup){
				m_pos.SetPos(result);
				return findup();
			}else return false;
		}else{
			DeleteCommand del(result,end);
			Command *re = del(this);
			if(re == NULL)return false;
			m_undo.AddUndoHist(re);
			InsertCommand ins(result,r);
			re = ins(this);
			if(re == NULL)return false;
			else m_undo.AddUndoHist(re);
			return true;
		}
	}else return true;
}

bool EditWnd::findup(){
	if(m_set.readonly)return false;
	POS result;
	int len = m_search.FindUp(result);
	escape();
	if(len == -1)return false;
	POS oldpos = m_pos.GetPos();
	POS end = result;
	end.column += len;
	ablib::string r = m_search.GetReplaceStr(m_replacestr);
	m_pos.SetSel(result,end);
	if(m_search.SearchOption() & replace){
		ablib::string r = m_search.GetReplaceStr(m_replacestr);
		AskDlg askdlg;
		if(m_search.SearchOption() & ask){
			int a = askdlg.Ask(m_appint,GetWindow());
			if(a == AskDlg::replace || a == AskDlg::replacenext || a == AskDlg::all){
				DeleteCommand del(result,end);
				Command *re = del(this);
				if(re == NULL)return false;
				m_undo.AddUndoHist(re);
				InsertCommand ins(result,r);
				re = ins(this);
				if(re == NULL)return false;
				else m_undo.AddUndoHist(re);
				if(a == AskDlg::replacenext)return findup();
				else if(a == AskDlg::all){
					ablib::string fl = m_search.SearchOptionStr();
					fl.erase(fl.find(_T("ask")),3);
					if(replaceall(m_search.SearchBuffer(),m_replacestr,fl,true) != -1)return true;
					else return false;
				}else return true;
			}else if(a == AskDlg::searchdown){
				m_pos.SetPos(end);
				return finddown();
			}else if(a == AskDlg::searchup){
				m_pos.SetPos(result);
				return findup();
			}else return false;
		}else{
			DeleteCommand del(result,end);
			Command *re = del(this);
			if(re == NULL)return false;
			m_undo.AddUndoHist(re);
			InsertCommand ins(result,r);
			re = ins(this);
			if(re == NULL)return false;
			else m_undo.AddUndoHist(re);
			return true;
		}
	}else return true;
}

//}NiHjn
void EditWnd::disabledraw(){
	if(m_isdraw){
		m_isdraw = false;
		SetCaret(false);
	}
}

void EditWnd::enabledraw(){
	if(!m_isdraw){
		m_isdraw = true;
		SetCaret(true);
		SetScroll();
		if(GetWindow()){
			GetWindow()->Invalidate();
		}
	}
}

//J[\֘A
int EditWnd::code(){
	const TCHAR *str = m_buf.GetText(m_pos.GetPos().lineno);
	if(str == NULL)return 0;
	if(str[m_pos.GetPos().column] == '\0'){
		if(m_pos.GetPos().lineno == m_buf.GetLineCount() - 1)return -1;
		else return '\n';
	}
#ifdef UNICODE
	return str[m_pos.GetPos().column];
#else
	if(ablib::IsKanji(str[m_pos.GetPos().column]))return str[m_pos.GetPos().column] + 256 * str[m_pos.GetPos().column];
	else return str[m_pos.GetPos().column];
#endif
}

//eLXg֘A
int EditWnd::linelen(){
	return m_buf.GetLineLen(m_pos.GetXY().y);
}

int EditWnd::linelen2(){
	const TCHAR *str = m_buf.GetText(m_pos.GetPos().lineno);
	if(str == NULL)return 0;
	else return ::lstrlen(str);
}

}//namespace window
}//namespace ablib