#ifndef __ABLIB_WINDOW_EDIT_HILIGHT_H__
#define __ABLIB_WINDOW_EDIT_HILIGHT_H__

#include "RegEx_Def.h"
#include "memory.h"
#include "struct.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{
namespace edit{

/**
* FsD
* ̂LbVƂgo܂D
*/

class Hilight{
public:
	enum option{
		valid = 1,
		line = 4,
		nocasesense = 8,
		regular = 16,
		word = 32
	};
	Hilight(Memory *m) : m_memory(m){};
	~Hilight(){};

	bool AddHilightData(const TCHAR *keyword,int opt,int hilightpos);
	void Clear(){m_hilight.clear();}

	//result[0]ɑŜ̈ʒuƏꏊDԖڈȍ~ɃnCCgׂʒuƏꏊD
	bool Match(const TCHAR *str,int i,SmallVector<PosLen> &result);
	int GetHilightNum() const{return m_hilight.size();}

private:
	Memory *m_memory;

	struct HilightData{
		int option;
		ABLIB_WINDOW_EDIT_REGEX reg;
		ablib::string word;
		int hilightpos;
	};

	SmallVector<HilightData> m_hilight;

};

}//namespace edit
}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_EDIT_HILIGHT_H__

