#include "edit.h"
#include "layout.h"
#include "struct.h"
#include "../ablib/IsKanji.h"
#include "../ablib/BMSearch.h"

namespace ablib{
namespace window{
namespace edit{

//start <= line < oldend폜Cstart <= line < newend̏ǉD
//G[`FbN͂ȂDԈf[^nƂ܂D
void Layout::DoLayout(int start,int oldend,int newend){
	int starty;
	if(start == m_linetoy.size())starty = m_linetoy.size();
	else starty = LineToY(start);
	int endy;
	if(oldend == m_linetoy.size())endy = m_layout.size();
	else endy = LineToY(oldend);
	//폜
	m_layout.erase(m_layout.begin() + starty,m_layout.begin() + endy);
	m_linetoy.erase(m_linetoy.begin() + start,m_linetoy.begin() + oldend);
	//lߍވʒu
	std::vector<LayoutData>::iterator pushdata = m_layout.begin() + starty;
	std::vector<int>::iterator pushy = m_linetoy.begin() + start;
//	m_layout.reserve(m_memory->GetLineCount());
	//yW
	int addy = starty;
	for(int line = start ; line < newend ; ++line){
		pushy = m_linetoy.insert(pushy,addy);
		++pushy;
		int drawlen = 0,strlen = 0;
		const TCHAR *str = m_memory->GetText(line);
		if(str == NULL)break;
		//es𒲂ׂ
		const TCHAR *p;
		for(p = str; *p ; ++p){
#ifndef UNICODE
			if(ablib::IsKanji(*p)){
				//2BYTE̎
				if(drawlen == m_maxx || drawlen == m_maxx - 1){
					pushdata = m_layout.insert(pushdata,LayoutData(line,p - str - strlen,strlen));
					++pushdata;++addy;
					++p;drawlen = strlen = 2;
				}else{++p;drawlen += 2;strlen += 2;}
			}else
#endif
			if(*p == '\t'){
				//tab̎
				if(drawlen + m_tabsize > m_maxx){
					pushdata = m_layout.insert(pushdata,LayoutData(line,p - str - strlen,strlen));
					++pushdata;++addy;
					drawlen = m_tabsize;strlen = 1;
				}else{
					//tab̌vZ
					++drawlen;++strlen;
					for(;drawlen % m_tabsize ; ++drawlen);
				}
			}else{
				//
				if(drawlen == m_maxx){
					pushdata = m_layout.insert(pushdata,LayoutData(line,p - str - strlen,strlen));
					++pushdata;++addy;
					strlen = drawlen = 1;
				}else{++drawlen;++strlen;}
			}
		}
		pushdata = m_layout.insert(pushdata,LayoutData(line,p - str - strlen,strlen));
		++pushdata;++addy;
	}
	//̕liney炷D
	if(addy - endy != 0){
		for(int i = newend ; i < m_linetoy.size(); ++i)m_linetoy[i] += addy - endy;
	}
	if(newend - oldend != 0){
		for(int i = addy  ; i < m_layout.size() ; ++i)m_layout[i].line += newend - oldend;
	}
//	DUMP();
}


XY Layout::POSToXY(POS pos){
	if(pos.lineno < 0 || pos.lineno >= m_memory->GetLineCount()){
		ASSERT(false);
		return XY(-1,-1);
	}
	int lasty;
	if(pos.lineno == m_memory->GetLineCount() - 1)lasty = GetLayoutLineCount() - 1;
	else lasty = LineToY(pos.lineno + 1) - 1;
	if(pos.column == GetLayoutData(lasty).offset + GetLayoutData(lasty).length){
		//s̈ԍŌɂ鎞̓ꏈ
		const TCHAR *str = m_memory->GetText(pos.lineno) + GetLayoutData(lasty).offset;
		int tabs = 0;
		const TCHAR *p = str;
		while(p = ablib::BMSearch::strstr(p,_T("\t"))){
			int add = tabs + p - str + 1;
			for(; add % m_tabsize ; ++add);
			tabs = add - (p - str) - 1;
			++p;
		}
		return XY(GetLayoutData(lasty).length + tabs,lasty);
	}
	int y = LineToY(pos.lineno);
	//ei
	for(int i = pos.column / m_maxx ; i + y < GetLayoutLineCount() ; ++i){
		if(m_layout[i + y].line != pos.lineno){
			DEBUGSTRING(_T("window::Layout : m_layout[%d].line = %d"),i + y,m_layout[i + y].line);
			ASSERT(false);
			return XY(-1,-1);
		}
		if(pos.column < m_layout[i + y].length + m_layout[i + y].offset){
			//Yy𓾂̂tabɂ␳vZ܂ĕԂD
			const TCHAR *str = m_memory->GetText(pos.lineno);
			str += m_layout[i + y].offset;
			const TCHAR *p,*q;
			q = str;
			int tabs = 0;
			while((p = ablib::BMSearch::strstr(q,_T("\t"))) && p < str + pos.column - m_layout[i + y].offset){
				int add = tabs + p - str + 1;
				for(;add % m_tabsize ; ++add);
				tabs = add - (p - str) - 1;
				q = p + 1;
			}
			XY rv = XY(pos.column - m_layout[i + y].offset + tabs,i + y);
			return rv;
		}
	}
	ASSERT(false);
	return XY(-1,-1);
}

POS Layout::XYToPOS(XY xy){
	if(xy.y < 0 || xy.y >= GetLayoutLineCount()){
		ASSERT(false);
		return POS(-1,-1);
	}
	int line = YToLine(xy.y);
	const TCHAR *str = m_memory->GetText(line) + GetLayoutData(xy.y).offset;
	int len = GetLayoutData(xy.y).length;
	int x = 0;
	const TCHAR *p,*q;
	q = str;
	int tabs = 0;
	//yWtablČvZ
	while((p = ablib::BMSearch::strstr(q,_T("\t"))) && p <= str + len){
		if(tabs + p - str >= xy.x)break;
		int add = tabs + p - str;
		++add;
		for(;add % m_tabsize ; ++add);
		if(add - 1 > xy.x){
			xy.x = tabs + p - str;
			break;
		}
		tabs = add - (p - str) - 1;
		q = p + 1;
	}
	return POS(line,xy.x - tabs + GetLayoutData(xy.y).offset);
}

/*
}
#include <stdio.h>
namespace window{
void Layout::DUMP(){
	FILE *fp = ::_tfopen(_T("c:\\tmp\\test.txt"),_T("a"));
	::_ftprintf(fp,_T("layout\n"));
	for(UINT i = 0 ; i < m_layout.size() ; ++i){
		::_ftprintf(fp,_T("y : %d,line : %d,offset : %d,length : %d\n"),i,m_layout[i].line,m_layout[i].offset,m_layout[i].length);
	}
	::_ftprintf(fp,_T("\nlinetoy\n"));
	for(UINT i = 0 ; i < m_linetoy.size() ; ++i){
		::_ftprintf(fp,_T("line : %d,y : %d\n"),i,m_linetoy[i]);
	}
	::_ftprintf(fp,_T("\n\n"));
	::fclose(fp);
}
*/

}//namespace edit
}//namespace window
}//namespace ablib