#ifndef __ABLIB_WINDOW_EDIT_MEMORY_H__
#define __ABLIB_WINDOW_EDIT_MEMORY_H__

//#include "../../ablib/list.h"
#include <list>
#include "struct.h"

namespace ablib{
namespace window{
namespace edit{

/**
* obt@ǗD
* Ƃ肠list + stringłCx̂ł̂܂D
*/

class Memory{
public:
	Memory();
	~Memory();
	int GetLineCount() const{return m_buf.size();}
	const TCHAR *GetText(int line);
	const TCHAR *GetText(POS start,POS end,const TCHAR *sep);
	bool InsertText(POS pos,POS &endpos,const TCHAR *str,const TCHAR *sep);
	const TCHAR *DeleteText(POS start,POS end,const TCHAR *sep);
	void RemoveAll();
	int GetMaxLength() const{return m_maxlen;}

	void SetTabSize(int tab){m_tabsize = (tab > 0 ? tab : 1);}

private:
	typedef std::list<ablib::string>::iterator iterator;
	typedef std::list<ablib::string>::const_iterator const_iterator;
	std::list<ablib::string> m_buf;
	int m_maxlen;
	int m_tabsize;

	//̈
	iterator SearchLine(int line);
	mutable int m_lastline;
	mutable iterator m_lastpos;

	int GetLayoutLen(ablib::string &str);

};

}//namespace edit
}//namespace window
}//namespace ablib

#endif ///__ABLIB_WINDOW_EDIT_MEMORY_H__

