#include "hmjre.h"
#include "RegEx.h"
#include "../ablib/IsKanji.h"
#include "../system/Registory.h"

namespace HmJre{

extern ablib::string g_dllname;
ablib::string tmp_string;

RegEx::RegEx() : m_dll(NULL),m_JreGetVersion(NULL),m_FuzzyOptionDialog(NULL),m_EnvChanged(NULL),m_iscompiled(false){
	::ZeroMemory(&m_jre2,sizeof(JRE2));m_jre2.dwSize = sizeof(JRE2);
	::ZeroMemory(&m_fuzzy,sizeof(JREFUZZYDATA));m_fuzzy.dwSize = sizeof(JREFUZZYDATA);
}
RegEx::RegEx(const TCHAR *reg) : m_dll(NULL),m_JreGetVersion(NULL),m_FuzzyOptionDialog(NULL),m_EnvChanged(NULL),m_iscompiled(false){
	::ZeroMemory(&m_jre2,sizeof(JRE2));m_jre2.dwSize = sizeof(JRE2);
	::ZeroMemory(&m_fuzzy,sizeof(JREFUZZYDATA));m_fuzzy.dwSize = sizeof(JREFUZZYDATA);
	Compile(reg);
}
RegEx::RegEx(const RegEx &obj) : m_dll(NULL),m_JreGetVersion(NULL),m_FuzzyOptionDialog(NULL),m_EnvChanged(NULL),m_iscompiled(false),m_opt(obj.m_opt),m_fuzzyopt(obj.m_fuzzyopt){
	::ZeroMemory(&m_jre2,sizeof(JRE2));m_jre2.dwSize = sizeof(JRE2);
	::ZeroMemory(&m_fuzzy,sizeof(JREFUZZYDATA));m_fuzzy.dwSize = sizeof(JREFUZZYDATA);
	if(obj.m_iscompiled)Compile(obj.m_reg);
}
RegEx &RegEx::operator=(const RegEx &obj){
	::ZeroMemory(&m_jre2,sizeof(JRE2));m_jre2.dwSize = sizeof(JRE2);
	::ZeroMemory(&m_fuzzy,sizeof(JREFUZZYDATA));m_fuzzy.dwSize = sizeof(JREFUZZYDATA);
	m_opt = obj.m_opt;
	m_fuzzyopt = obj.m_fuzzyopt;
	m_iscompiled = false;
	if(obj.m_iscompiled)Compile(obj.m_reg);
	return *this;
}
RegEx::~RegEx(){
	UnLoadDLL();
}

/** IvVݒD
* @param set ݒ肷IvV
	- "aimai" : BgpDftHgfalseD
	- "word" : P̌gpDftHgfalseD
	- "CaseSense" : 啶ʂDftHgtrueD
	- "zero_match" : 0̃}b`}b`ƌȂǂݒ肷DftHgtrueD
	- "use_regular" : K\gǂDftHgtrueD
* @param val true܂falseD
* @return trueCsfalseD
*/
bool RegEx::SetOpt(const TCHAR *set,bool val){
#define SETOPT(s) if(::lstrcmpi(_T( #s ),set) == 0){m_opt. ## s = val;return true;}
	SETOPT(CaseSense);
	SETOPT(word);
	SETOPT(zero_match);
	SETOPT(use_regular);
	SETOPT(aimai);
#undef SETOPT
	return false;
}

/** BIvVݒibooleanjD
* @param set ݒ肷IvV
	- "use_registory" : WXggǂDgȂꍇCfalsew肵Ă瑼ݒ肷邱ƁDfalseŐݒ肵ɁCSĂ̐ݒ̓WXg̓eŏDftHgtrueD
	- "nohanzen" : p^SpʂȂD
	- "nohirakata" : Ђ炪ȂƃJ^JiʂȂD
	- "nobigsmallkana" : 傫uvƏuvʂȂD
	- "nodakuon" : CʂȂDúvCu΁vCuρv𓯈ꎋD
	- "kanahyphen" : Ȃ́u[vƉṕu|v𓯈ꎋD
	- "nospace" : 󔒁^^u𖳎D
	- "noreturn" : s𖳎D
	- "customignore" F 蕶𖳎DV1.09D
* @param val true܂falseD
* @return trueCsfalseD
*/
bool RegEx::SetFuzzyOpt(const TCHAR *set,bool val){
	if(::lstrcmpi(set,_T("use_registory")) == 0){
		m_fuzzyopt.use_registory = val;
		if(!m_fuzzyopt.use_registory){
			// WXg̓eŏ
			ablib::system::Registory registory;
			if(!registory.Open(HKEY_CURRENT_USER,_T("Software\\Hidemaruo\\HmJre")))return false;
			m_fuzzyopt.flag = registory.ReadDWORD(_T("FuzzyFlag"));
			m_fuzzyopt.ignore = registory.ReadStr(_T("CustomIgnore"));
			m_fuzzyopt.custom1 = registory.ReadStr(_T("Custom1"));
			m_fuzzyopt.custom2 = registory.ReadStr(_T("Custom2"));
			m_fuzzyopt.custom3 = registory.ReadStr(_T("Custom3"));
			m_fuzzyopt.custom4 = registory.ReadStr(_T("Custom4"));
			registory.Close();
		}
		return true;
	}
#define SETOPT(s) if(::lstrcmpi(_T( #s ),set) == 0){if(val)m_fuzzyopt.flag |= FUZZYOPTION_ ## s;else m_fuzzyopt.flag &= ~FUZZYOPTION_ ## s ;return true;}
	SETOPT(NOHANZEN)
	SETOPT(NOHIRAKATA)
	SETOPT(NOBIGSMALLKANA)
	SETOPT(NODAKUON)
	SETOPT(KANAHYPHEN)
	SETOPT(NOSPACE)
	SETOPT(NORETURN)
	SETOPT(CUSTOMIGNORE)
#undef SETOPT
	return false;
}

/** BIvVݒiljD
* @param set ݒ肷IvV
	- "noreturn_lines" : s̐
* @param val ݒ肷l
* @return trueCsfalseD
*/
bool RegEx::SetFuzzyOpt(const TCHAR *set,int val){
	if(::lstrcmpi(set,_T("noreturn_lines")) == 0){
		if(val < 1)val = 1;else if(val > 8)val = 8;
		m_fuzzyopt.flag &= ~FUZZYOPTION_NORETURN_MASK;
		m_fuzzyopt.flag |= ((val - 1) << FUZZYOPTION_NORETURN_SHIFT);
		return true;
	}
	return false;
}

/** BIvVݒijD
* @param set ݒ肷IvV
	- "Ignore" : 镶D
	- "Custom1" : JX^PD
	- "Custom2" : JX^QD
	- "Custom3" : JX^RD
	- "Custom4" : JX^SD
* @param val true܂falseD
* @return trueCsfalseD
*/
bool RegEx::SetFuzzyOpt(const TCHAR *set,const TCHAR *val){
#define SETOPT(s) if(::lstrcmpi(_T( #s ),set) == 0){m_fuzzyopt. ## s = val;return true;}
	SETOPT(ignore)
	SETOPT(custom1)
	SETOPT(custom2)
	SETOPT(custom3)
	SETOPT(custom4)
#undef SETOPT
	return false;
}


bool RegEx::Compile(const TCHAR *reg){
	m_reg = reg;
	// HmJregȂꍇD
	if(!m_opt.aimai && !m_opt.use_regular){
		if(*reg == '\0'){
			m_iscompiled = false;
			return false;
		}
		m_iscompiled = true;
		if(m_opt.CaseSense){
			m_bmsearch.Compile(reg);
		}else{
			ablib::string r = reg;
			r.tolower();
			m_bmsearch.Compile(r);
		}
		return true;
	}
	// 
	if(!LoadDLL())return false;
	m_iscompiled = false;
	auto a = &m_jre2;
	(*m_Jre2Close)(&m_jre2);
	::ZeroMemory(&m_jre2,sizeof(JRE2));
	m_jre2.dwSize = sizeof(JRE2);
	if(!(*m_Jre2Open)(&m_jre2))return false;
	if(m_opt.aimai){
		(*m_FuzzyClose)(&m_fuzzy);
		::ZeroMemory(&m_fuzzy,sizeof(JREFUZZYDATA));
		m_fuzzy.dwSize = sizeof(JREFUZZYDATA);
		// IvVWXgǂݏoȂꍇ́C
		// uWXgD
		ablib::system::Registory registory;
		FuzzyOption fopt;
		if(!m_fuzzyopt.use_registory && !SetRegistory(fopt,registory))return false;
		if(!(*m_FuzzyOpen)(&m_fuzzy,FALSE))return false;
		if(!m_fuzzyopt.use_registory && !RecoverRegistory(fopt,registory))return false;

		if(!m_opt.CaseSense)m_fuzzy.flags &= FUZZYOPTION_NOCASE;
	}
	if(m_opt.aimai){
		if(!(*m_FuzzyConvertFindString)(&m_fuzzy,reg,m_opt.use_regular ? 1 : 2))return false;
		m_iscompiled = (*m_Jre2Compile)(&m_jre2,m_fuzzy.pszFindConved) ? true : false;
		return m_iscompiled;
	}else{
		if(m_opt.CaseSense){
			m_iscompiled = (*m_Jre2Compile)(&m_jre2,const_cast<TCHAR*>(reg)) ? true : false;
			return m_iscompiled;
		}else{
			ablib::string r = reg;
			r.tolower();
			m_iscompiled = (*m_Jre2Compile)(&m_jre2,const_cast<TCHAR*>(r.c_str())) ? true : false;
			return m_iscompiled;
		}
	}
}

bool RegEx::Match(const TCHAR *str,int start){
	if(!m_iscompiled)return false;
	m_searchstr = str;
	// BMSearchɂʏ팟
	if(!m_opt.aimai && !m_opt.use_regular){
		if(m_opt.word){
			// P̌D
			ablib::string s;
			const TCHAR *p;
			if(m_opt.CaseSense)p = str;
			else{
				s = str;
				s.tolower();
				p = s.c_str();
			}
			p += start;
			while(true){
				if(!m_bmsearch.Match(p))return false;
				const TCHAR *q = p + m_bmsearch.GetMatchPos();
				if(
					(q == str || !IsEitango(*(q - 1))) &&
					!IsEitango(*(q + m_bmsearch.GetMatchLen()))
				){
					m_jre2.nPosition = (q - str);
					m_matchstr = m_bmsearch.GetMatchStr();
					return true;
				}else ++p;
			}
		}else{
			if(m_opt.CaseSense){
				if(m_bmsearch.Match(str + start)){
					m_jre2.nPosition = m_bmsearch.GetMatchPos() + start;
					m_matchstr = m_bmsearch.GetMatchStr();
					return true;
				}else return false;
			}else{
				ablib::string s = str;s.tolower();
				if(m_bmsearch.Match(s.c_str() + start)){
					m_jre2.nPosition = m_bmsearch.GetMatchPos() + start;
					m_matchstr = m_bmsearch.GetMatchStr();
					return true;
				}else return false;
			}
		}
	}
	if(!LoadDLL())return false;
	const TCHAR *target;
	ablib::string t;
	size_t targetlen;
	if(m_opt.aimai){
		(*m_FuzzyConvertTarget)(&m_fuzzy,str);
		target = m_fuzzy.pszTargetConved;
		targetlen = ::lstrlen(target);
	}else if(m_opt.CaseSense){
		target = str;
		targetlen = ::lstrlen(target);
	}else{
		t = str;
		t.tolower();
		target = t.c_str();
		targetlen = t.length();
	}
	if(m_opt.word){
		m_jre2.nStart = start;
		while(true){
			// Ƃ肠
			if(!(*m_Jre2GetMatchInfoHmJre)(&m_jre2,const_cast<TCHAR*>(target),targetlen))return false;
			// [}b`s\̏ꍇF̌D
			if(!m_opt.zero_match && m_jre2.nLength == 0){
				++m_jre2.nStart;
				if(targetlen == m_jre2.nStart)return false;
				continue;
			}
			// str + pos ` str + pos + lenʂɂȂ悤poslenɑD
			int pos,len = m_jre2.nLength;
			if(m_opt.aimai)pos = (*m_FuzzyFindArea2RealArea)(&m_fuzzy,m_jre2.nPosition,&len);
			else pos = m_jre2.nPosition;
			// P`FbND
			if(
				(pos == 0 || !IsEitango(target[pos - 1])) && 
				(pos + len >= targetlen || !IsEitango(target[pos + len]))
			)
			{
				//ʂD
				m_matchstr.assign(str,pos,len);
				break;
			}
			m_jre2.nStart += m_jre2.nPosition + 1;
		}
	}else{
		//ʏ팟
		m_jre2.nStart = start;
		while(true){
			if(!(*m_Jre2GetMatchInfoHmJre)(&m_jre2,const_cast<TCHAR*>(target),targetlen))return false;
			if(!m_opt.zero_match && m_jre2.nLength == 0){
				++m_jre2.nStart;
				if(targetlen == m_jre2.nStart)return false;
				continue;
			}else break;
		}
		if(m_opt.aimai){
			int pos,len = m_jre2.nLength;
			pos = (*m_FuzzyFindArea2RealArea)(&m_fuzzy,m_jre2.nPosition,&len);
			m_matchstr.assign(str,pos,len);
		}else m_matchstr.assign(str,m_jre2.nPosition,m_jre2.nLength);
	}
	return true;
}

const TCHAR *RegEx::GetMatchStr(int i){
	int len;
	int pos = (*m_JreGetTagPosition)(&m_jre2,i + '0',&len);
	if(pos == -1)return _T("");
	if(m_opt.aimai)pos = (*m_FuzzyFindArea2RealArea)(&m_fuzzy,pos,&len);
	tmp_string.assign(m_searchstr,pos,len);
	return tmp_string.c_str();
}

const TCHAR *RegEx::GetMatchStr(const TCHAR *str){
    ablib::string rv;
	if(!m_opt.use_regular)return str;
	struct TagStr{
		TagStr() : isload(false){}
		bool isload;
		ablib::string str;
	};
	TagStr tags[10];
	rv.reserve(::lstrlen(str));
	int n;
	const TCHAR *p = str,*q = p;
	rv = _T("");
	while(*p){
#ifndef UNICODE
		if(ablib::IsKanji(*p))p = p + 2;
		else if(*p == '\\'){
#else
		if(*p == '\\'){
#endif
			++p;
			n = *p - '1';
			if(n >= 0 && n < 9){
				rv.append(q,0,p - q - 1);
				if(!tags[n].isload){
					tags[n].str = GetMatchStr(n + 1);
					tags[n].isload = true;
				}
				rv += tags[n].str;
			}else if(*p == '\\'){
				rv.append(q,0,p - q);
			}else if(*p == 'n'){
				rv.append(q,0,p - q - 1);
				rv += _T("\n");
			}else if(*p == 't'){
				rv.append(q,0,p - q - 1);
				rv += _T("\t");
			}else continue;
			++p;q = p;
		}else ++p;
	}
	rv += q;
	tmp_string = rv;
	return tmp_string.c_str();
}

size_t RegEx::GetMatchLen(int i){
	if(i == 0)return GetMatchLen();
	int len;
	int pos = (*m_JreGetTagPosition)(&m_jre2,i + '0',&len);
	if(pos == -1)return 0;
	if(m_opt.aimai)pos = (*m_FuzzyFindArea2RealArea)(&m_fuzzy,pos,&len);
	return len;
}

intptr_t RegEx::GetMatchPos(int i){
	if(i == 0)return GetMatchPos();
	int len;
	intptr_t pos = (*m_JreGetTagPosition)(&m_jre2,i + '0',&len);
	if(pos == -1)return -1;
	if(m_opt.aimai)pos = (*m_FuzzyFindPos2RealPos)(&m_fuzzy,pos);
	return pos;
}

intptr_t RegEx::GetMatchPos(){
	if(!m_opt.aimai)return m_jre2.nPosition;
	else return (*m_FuzzyFindPos2RealPos)(&m_fuzzy,m_jre2.nPosition);
}

	
size_t RegEx::GetTokenNum(){
	int len;
	for(size_t i = 1 ; i < 10 ; ++i){
		if((*m_JreGetTagPosition)(&m_jre2,i + '0',&len) == -1)return i;
	}
	return 9;
}

bool RegEx::LoadDLL(){
	if(m_dll)return true;
	m_dll = ::LoadLibrary(g_dllname.c_str());
	if(!m_dll)return false;
	m_Jre2Open = reinterpret_cast<LPJRE2OPEN>(::GetProcAddress(m_dll,_T("Jre2Open")));
	m_Jre2Compile = reinterpret_cast<LPJRE2COMPILE>(::GetProcAddress(m_dll,_T("Jre2Compile")));
	m_Jre2Close = reinterpret_cast<LPJRE2CLOSE>(::GetProcAddress(m_dll,_T("Jre2Close")));
	m_Jre2GetMatchInfoHmJre = reinterpret_cast<LPJRE2GETMATCHINFO_HMJRE>(::GetProcAddress(m_dll,_T("Jre2GetMatchInfo_HmJre")));
	m_GetJreMessage = reinterpret_cast<LPGETJREMESSAGE>(::GetProcAddress(m_dll,_T("GetJreMessage")));
	m_JreGetTagPosition = reinterpret_cast<LPJREGETTAGPOSITION>(::GetProcAddress(m_dll,_T("JreGetTagPosition")));
	m_FuzzyOpen = reinterpret_cast<LPFUZZY_OPEN>(::GetProcAddress(m_dll,_T("Fuzzy_Open")));
	m_FuzzyClose = reinterpret_cast<LPFUZZY_CLOSE>(::GetProcAddress(m_dll,_T("Fuzzy_Close")));
	m_FuzzyConvertTarget = reinterpret_cast<LPFUZZY_CONVERTTARGET>(::GetProcAddress(m_dll,_T("Fuzzy_ConvertTarget")));
	m_FuzzyConvertFindString = reinterpret_cast<LPFUZZY_CONVERTFINDSTRING>(::GetProcAddress(m_dll,_T("Fuzzy_ConvertFindString")));
	m_FuzzyFindPos2RealPos = reinterpret_cast<LPFUZZY_FINDPOS2REALPOS>(::GetProcAddress(m_dll,_T("Fuzzy_FindPos2RealPos")));
	m_FuzzyFindArea2RealArea = reinterpret_cast<LPFUZZY_FINDAREA2REALAREA>(::GetProcAddress(m_dll,_T("Fuzzy_FindArea2RealArea")));
	m_FuzzyRealPos2FindPos = reinterpret_cast<LPFUZZY_REALPOS2FINDPOS>(::GetProcAddress(m_dll,_T("Fuzzy_RealPos2FindPos")));
	if(
		!m_Jre2Open               || !m_Jre2Compile            || !m_Jre2Close              ||
		!m_Jre2GetMatchInfoHmJre  || !m_JreGetTagPosition      || !m_FuzzyOpen              ||
		!m_FuzzyClose             || !m_FuzzyConvertTarget     || !m_FuzzyConvertFindString ||
		!m_FuzzyFindPos2RealPos   || !m_FuzzyFindArea2RealArea || !m_FuzzyRealPos2FindPos   ||
		!m_GetJreMessage
	){
		::FreeLibrary(m_dll);
		m_dll = NULL;
		return false;
	}
	return true;
}

bool RegEx::UnLoadDLL(){
	if(m_dll){
		( *m_Jre2Close )( &m_jre2 );
		( *m_FuzzyClose )( &m_fuzzy );
		::FreeLibrary(m_dll);
		m_dll = NULL;
		m_JreGetVersion = NULL;
		m_FuzzyOptionDialog = NULL;
	}
	return true;
}

WORD RegEx::GetVer(){
	HMODULE dll = ::LoadLibrary(g_dllname.c_str());
	if(dll == 0)return 0;
	LPJREGETVERSION GetVersion = reinterpret_cast<LPJREGETVERSION>(::GetProcAddress(dll,_T("JreGetVersion")));
	if(!GetVersion)return 0;
	WORD rv = (*GetVersion)();
	::FreeLibrary(dll);
	return rv;
}

bool RegEx::GetErrorMessage(ablib::string &out){
	if(!LoadDLL())return FALSE;
	TCHAR buf[JRE_MAXLEN+1];
	if((*m_GetJreMessage)(m_jre2.nError,GJM_JPN,buf,JRE_MAXLEN+1))return false;
	out = buf;
	return true;
}

BOOL RegEx::OptionDialog(HWND hwnd){
	if(!LoadDLL())return FALSE;
	if(!m_FuzzyOptionDialog){
		m_FuzzyOptionDialog = reinterpret_cast<LPFUZZY_OPTIONDIALOG>(::GetProcAddress(m_dll,_T("Fuzzy_OptionDialog")));
		if(!m_FuzzyOptionDialog)return FALSE;
	}
	return (*m_FuzzyOptionDialog)(hwnd,0);
}

bool RegEx::SetRegistory(FuzzyOption &old,ablib::system::Registory &registory){
	if(!m_EnvChanged){
		m_EnvChanged = reinterpret_cast<LPENVCHANGED>(::GetProcAddress(m_dll,_T("EnvChanged")));
		if(!m_EnvChanged)return false;
	}
	if(!registory.Open(HKEY_CURRENT_USER,_T("Software\\Hidemaruo\\HmJre")))return false;
	old.flag = registory.ReadDWORD(_T("FuzzyFlag"));
	old.ignore = registory.ReadStr(_T("CustomIgnore"));
	old.custom1 = registory.ReadStr(_T("Custom1"));
	old.custom2 = registory.ReadStr(_T("Custom2"));
	old.custom3 = registory.ReadStr(_T("Custom3"));
	old.custom4 = registory.ReadStr(_T("Custom4"));

	if(m_fuzzyopt.flag != old.flag)registory.WriteDWORD(_T("FuzzyFlag"),m_fuzzyopt.flag);
	if(m_fuzzyopt.ignore != old.ignore)registory.WriteStr(_T("CustomIgnore"),m_fuzzyopt.ignore);
	if(m_fuzzyopt.custom1 != old.custom1)registory.WriteStr(_T("Custom1"),m_fuzzyopt.custom1);
	if(m_fuzzyopt.custom2 != old.custom2)registory.WriteStr(_T("Custom2"),m_fuzzyopt.custom2);
	if(m_fuzzyopt.custom3 != old.custom3)registory.WriteStr(_T("Custom3"),m_fuzzyopt.custom3);
	if(m_fuzzyopt.custom4 != old.custom4)registory.WriteStr(_T("Custom4"),m_fuzzyopt.custom4);
	(*m_EnvChanged)();
	return true;
}

bool RegEx::RecoverRegistory(const FuzzyOption &old,ablib::system::Registory &registory){
	if(m_fuzzyopt.flag != old.flag)registory.WriteDWORD(_T("FuzzyFlag"),old.flag);
	if(m_fuzzyopt.ignore != old.ignore)registory.WriteStr(_T("CustomIgnore"),old.ignore);
	if(m_fuzzyopt.custom1 != old.custom1)registory.WriteStr(_T("Custom1"),old.custom1);
	if(m_fuzzyopt.custom2 != old.custom2)registory.WriteStr(_T("Custom2"),old.custom2);
	if(m_fuzzyopt.custom3 != old.custom3)registory.WriteStr(_T("Custom3"),old.custom3);
	if(m_fuzzyopt.custom4 != old.custom4)registory.WriteStr(_T("Custom4"),old.custom4);
	(*m_EnvChanged)();
	registory.Close();
	return true;
}


}//namespace HmJre
