#ifndef __HMJRE_REGEX_H__
#define __HMJRE_REGEX_H__

#include "hmjre.h"
#include "../ablib/BMSearch.h"
#include "../system/Registory.h"

namespace HmJre{

typedef BOOL (FAR PASCAL *LPJRE2GETMATCHINFO_HMJRE)(LPJRE2,LPSTR,int);
typedef int (WINAPI *LPJREGETTAGPOSITION)(LPJRE2,char,int*);
typedef BOOL (WINAPI *LPFUZZY_OPEN)(JREFUZZYDATA*,BOOL);
typedef BOOL (WINAPI *LPFUZZY_CLOSE)(JREFUZZYDATA*);
typedef BOOL (WINAPI *LPFUZZY_CONVERTTARGET)(JREFUZZYDATA*,const char*);
typedef BOOL (WINAPI *LPFUZZY_CONVERTFINDSTRING)(JREFUZZYDATA*,const char*,BOOL);
typedef int (WINAPI *LPFUZZY_FINDPOS2REALPOS)(JREFUZZYDATA*,int);
typedef int (WINAPI *LPFUZZY_FINDAREA2REALAREA)(JREFUZZYDATA*,int,int*);
typedef int (WINAPI *LPFUZZY_REALPOS2FINDPOS)(JREFUZZYDATA*,int);
typedef BOOL (_cdecl *LPFUZZY_OPTIONDIALOG)(HWND,UINT);
typedef int (_cdecl *LPENVCHANGED)();


/**
* K\bpNXD
* GWhmjre.dllgpD
* SetDLLNameDLL̃pXw肵ĂׂD
* ʏ팟oD̎ablib::BMSearchgpD
*/



class RegEx{
public:
	RegEx();
	RegEx(const TCHAR *reg);
	RegEx(const RegEx &obj);
	~RegEx();
	HmJre::RegEx &operator=(const RegEx &obj);
	bool SetOpt(const TCHAR *set,bool val);
	bool SetFuzzyOpt(const TCHAR *set,bool val);
	bool SetFuzzyOpt(const TCHAR *set,const TCHAR *val);
	bool SetFuzzyOpt(const TCHAR *set,int val);

	bool Compile(const TCHAR *reg);
	bool Compile(const ablib::string &reg){return Compile(reg.c_str());}
	bool ReCompile(){return Compile(m_reg);}
	bool Match(const TCHAR *str,int start = 0);
	bool Match(const ablib::string &str,int start = 0){return Match(str.c_str(),start);}
	
	const TCHAR *GetMatchStr() const{return m_matchstr.c_str();}
	const TCHAR *GetMatchStr(int i);
	const TCHAR *GetMatchStr(const TCHAR *str);
	const TCHAR *GetMatchStr(const ablib::string &str){return GetMatchStr(str.c_str());}
	size_t GetMatchLen() const{return m_matchstr.length();}
	size_t GetMatchLen(int i);
	intptr_t GetMatchPos();
	intptr_t GetMatchPos(int i);
	bool IsCompiled() const{return m_iscompiled;}
	size_t GetTokenNum();
	BOOL OptionDialog(HWND hwnd);
	static WORD GetVer();
	
	bool GetErrorMessage(ablib::string &out);

private:
	bool LoadDLL();
	bool UnLoadDLL();

	bool IsEitango(TCHAR c){return (('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z') || (c == '_'));}

	HMODULE m_dll;
	bool m_iscompiled;
	ablib::BMSearch m_bmsearch;
	
	ablib::string m_reg,m_matchstr,m_searchstr;
	
	struct Option{
		Option() : CaseSense(true),word(false),zero_match(true),use_regular(true),aimai(false){}
		bool CaseSense;//啶ʂD
		bool word;//P̌D
		bool zero_match;//0̃}b`}b`Ƃ݂ȂD
		bool use_regular;//K\gD
		bool aimai;//BD
	}m_opt;
	struct FuzzyOption{
		FuzzyOption() : use_registory(true),flag(0){}
		bool use_registory;
		DWORD flag;
		ablib::string custom1,custom2,custom3,custom4;
		ablib::string ignore;
	}m_fuzzyopt;
	bool SetRegistory(FuzzyOption &old,ablib::system::Registory &registory);
	bool RecoverRegistory(const FuzzyOption &old,ablib::system::Registory &registory);
	

	JRE2 m_jre2;
	JREFUZZYDATA m_fuzzy;
	
	LPJRE2OPEN m_Jre2Open;
	LPJRE2COMPILE m_Jre2Compile;
	LPJRE2CLOSE m_Jre2Close;
	LPJREGETVERSION m_JreGetVersion;
	LPJREGETTAGPOSITION m_JreGetTagPosition;
	LPGETJREMESSAGE m_GetJreMessage;
	LPJRE2GETMATCHINFO_HMJRE m_Jre2GetMatchInfoHmJre;
	
	
	LPFUZZY_OPEN m_FuzzyOpen;
	LPFUZZY_CLOSE m_FuzzyClose;
	LPFUZZY_CONVERTTARGET m_FuzzyConvertTarget;
	LPFUZZY_CONVERTFINDSTRING m_FuzzyConvertFindString;
	LPFUZZY_FINDPOS2REALPOS m_FuzzyFindPos2RealPos;
	LPFUZZY_FINDAREA2REALAREA m_FuzzyFindArea2RealArea;
	LPFUZZY_REALPOS2FINDPOS m_FuzzyRealPos2FindPos;
	LPFUZZY_OPTIONDIALOG m_FuzzyOptionDialog;

	LPENVCHANGED m_EnvChanged;
};




}//namespace HmJre


#endif //__HMJRE_REGEX_H__

