#include "ablib_system.h"
#include "findfile.h"

namespace{
	inline bool IsRealFile(const TCHAR *file){
		return 
			!(
			(file[0] == '.' && file[1] == '\0') ||
			(file[0] == '.' && file[1] == '.' && file[2] == '\0')
			);
	}
}

namespace ablib{
namespace system{

bool FindFile::Begin(const TCHAR *pattern){
	if(m_find != INVALID_HANDLE_VALUE){SetLastError(ERROR_SUCCESS);return false;}
	m_find = ::FindFirstFile(pattern,&m_wfd);
	if(m_find == INVALID_HANDLE_VALUE){SetLastError();return false;}
	m_first = true;
	while(!IsRealFile(m_wfd.cFileName)){
		if(!::FindNextFile(m_find,&m_wfd)){
			SetLastError();
			Close();
			return false;
		}
	}
	return true;
}

bool FindFile::Next(WIN32_FIND_DATA *wfd){
	if(m_find == INVALID_HANDLE_VALUE){SetLastError(ERROR_SUCCESS);return false;}
	if(m_first){
		::CopyMemory(wfd,&m_wfd,sizeof(WIN32_FIND_DATA));
		m_first = false;
		return true;
	}
	if(!::FindNextFile(m_find,wfd)){SetLastError();return false;}
	while(!IsRealFile(wfd->cFileName)){
		if(!::FindNextFile(m_find,wfd)){SetLastError();return false;}
	}
	return true;
}

void FindFile::Close(){
	if(m_find != INVALID_HANDLE_VALUE){
		::FindClose(m_find);
		m_find = INVALID_HANDLE_VALUE;
	}
	m_first = true;
}

}//namespace system
}//namespace ablib


