#ifndef __ABLIB_SYSTEM_FINDFILE_H__
#define __ABLIB_SYSTEM_FINDFILE_H__

#include "ablib_system.h"

namespace ablib{
namespace system{

class FindFile
{
public:
	FindFile() : m_find(INVALID_HANDLE_VALUE),m_first(true){}
	~FindFile(){Close();}

	bool Begin(const TCHAR *pattern);
	bool Begin(const ablib::string &pattern){return Begin(pattern.c_str());}
	bool Next(WIN32_FIND_DATA *wfd);
	void Close();

private:
	HANDLE m_find;
	WIN32_FIND_DATA m_wfd;
	bool m_first;

	NOCOPY(FindFile);
};

}//namespace system
}//namespace ablib

#endif //__ABLIB_SYSTEM_FINDFILE_H__

