#include "ablib_system.h"
#include "Power.h"
#include "System.h"

namespace ablib{
namespace system{

bool Power::GetPrivileges(){
	HANDLE hToken;
	TOKEN_PRIVILEGES tp;

	if(!::OpenProcessToken(::GetCurrentProcess(),TOKEN_QUERY | TOKEN_ADJUST_PRIVILEGES,&hToken))return false;

	::LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME,&tp.Privileges[0].Luid);

	tp.PrivilegeCount = 1;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

	::AdjustTokenPrivileges(hToken,FALSE,&tp,0,NULL,0);

	return ::GetLastError() == ERROR_SUCCESS;
}

bool Power::LogOff(){
	return ::ExitWindowsEx(EWX_LOGOFF,0) != FALSE;
}
bool Power::Reboot(){
	if(m_system.Is98())return ::ExitWindowsEx(EWX_REBOOT,0) != FALSE;
	if(!GetPrivileges())return false;
	return ::ExitWindowsEx(EWX_REBOOT,0) != FALSE;
}
bool Power::ShutDown(){
	if(m_system.Is98())return ::ExitWindowsEx(EWX_SHUTDOWN,0) != FALSE;
	if(!GetPrivileges())return false;
	return ::ExitWindowsEx(EWX_SHUTDOWN,0) != FALSE;
}
bool Power::PowerOff(){
	if(m_system.Is98())return ::ExitWindowsEx(EWX_POWEROFF,0) != FALSE;
	if(!GetPrivileges())return false;
	return ::ExitWindowsEx(EWX_POWEROFF,0) != FALSE;
}



}//namespace system
}//namespace ablib

