#ifndef __ABLIB_SYSTEM_REGISTORY_H__
#define __ABLIB_SYSTEM_REGISTORY_H__

#include <vector>
#include "ablib_system.h"


namespace ablib{
namespace system{

class Registory
{
public:
	Registory() : m_handle(NULL){}
	~Registory(){Close();}
	bool Open(HKEY key,const TCHAR *path);
	bool Open(HKEY key,const ablib::string &path){return Open(key,path.c_str());}
	bool Create(HKEY key,const TCHAR *path);
	bool Create(HKEY key,const ablib::string &path){return Create(key,path.c_str());}
	ablib::string ReadStr(const TCHAR *entry);
	ablib::string ReadStr(const ablib::string &entry){return ReadStr(entry.c_str());}
	DWORD ReadDWORD(const TCHAR *entry);
	DWORD ReadDWORD(const ablib::string &entry){return ReadDWORD(entry.c_str());}
	bool WriteStr(const TCHAR *entry,const ablib::string &str);
	bool WriteStr(const ablib::string &entry,const ablib::string &str){return WriteStr(entry.c_str(),str);}
	bool WriteStrExpand(const TCHAR *entry,const ablib::string &str);
	bool WriteStrExpand(const ablib::string &entry,const ablib::string &str){return WriteStrExpand(entry.c_str(),str);}
	bool WriteDWORD(const TCHAR *entry,DWORD val);
	bool WriteDWORD(const ablib::string &entry,DWORD val){return WriteDWORD(entry.c_str(),val);}
	void Close(){::RegCloseKey(m_handle);m_handle = NULL;}
	bool Delete();
	bool Delete(const TCHAR *entry);
	bool Delete(const ablib::string &entry){return Delete(entry.c_str());}
	bool EnumKeys(std::vector<ablib::string> &rv);

private:
	HKEY m_handle,m_root;
	ablib::string m_path;
	bool DeleteKey(HKEY key,const ablib::string &path);
};

}//namespace system
}//namespace ablib

#endif //__REGISTORY_H__

