#include "ablib_system.h"
#include "System.h"

namespace ablib{
namespace system{

bool System::Is64bit(){
	if(IsWow64())return true;
	return (m_system.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_AMD64 || m_system.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_IA64);
}
bool System::IsWow64(){
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);
	LPFN_ISWOW64PROCESS funcIsWow64Process = reinterpret_cast<LPFN_ISWOW64PROCESS>(::GetProcAddress(GetModuleHandle(_T("kernel32")),"IsWow64Process"));
	if(funcIsWow64Process){
		BOOL rv;
		if(!funcIsWow64Process(::GetCurrentProcess(),&rv))return false;
		return (rv ? true : false);
	}else return false;
}

}
}