#include "ablib_window.h"
#include "Basemodaldlg.h"

namespace ablib{
namespace window{


intptr_t BaseModalDlg::Create(Wnd *parent,LPCTSTR id){
	return ::DialogBoxParam(m_appint,id,parent ? parent->GetHWND() : NULL,sDlgProc,reinterpret_cast<LPARAM>(this));
}

void BaseModalDlg::AddSubClass(SubClassDlg *sub,int id){
	m_subclass.push_back(SubClassData(sub,id));
	if(m_window){
		unsigned int i = m_subclass.size() - 1;
		m_subclass[i].hwnd = ::GetDlgItem(m_window->GetHWND(),id);
		m_subclass[i].subclass->SubClass(m_subclass[i].hwnd);
	}
}
void BaseModalDlg::AddSubClass(SubClassDlg *sub,HWND hwnd){
	m_subclass.push_back(SubClassData(sub,hwnd));
	if(m_window){
		unsigned int i = m_subclass.size() - 1;
		m_subclass[i].subclass->SubClass(m_subclass[i].hwnd);
	}
}

INT_PTR CALLBACK BaseModalDlg::sDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){
	BaseModalDlg *target = static_cast<BaseModalDlg*>(::GetProp(hwndDlg,_T("ABENORI_WINDOW_PROP")));
	if(!target){
		if(uMsg == WM_INITDIALOG)target = reinterpret_cast<BaseModalDlg*>(lParam);
		if(target){
			target->Atach(hwndDlg);
			target->m_window = new Dialog(hwndDlg);
			for(int i = 0 ; i < target->m_subclass.size() ; ++i){
				int id = target->m_subclass[i].id;
				target->m_subclass[i].subclass->SubClass(::GetDlgItem(hwndDlg,id));
			}
		}
	}
	if(target){
		Dialog *me = target->GetWindow();
		if(!me)return FALSE;
		
		{
			INT_PTR rv;
			if(target->PreTranslateMessage(me,uMsg,wParam,lParam,rv))return rv;
		}
		
		switch(uMsg){
		case WM_INITDIALOG:	return target->OnInitDialog(me) ? TRUE : FALSE;
		case WM_CLOSE:		return target->OnClose(me) ? TRUE : FALSE;
		case WM_DESTROY:
		{
			bool rv;
			if(rv = target->OnDestroy(me))target->Detach(hwndDlg);
			delete target->m_window;
			target->m_window = NULL;
			for(int i = 0 ; i < target->m_subclass.size() ; ++i){
				target->m_subclass[i].subclass->UnSubClass();
			}
			return rv ? TRUE : FALSE;
		}
		case WM_COMMAND:	return target->OnCommand(me,static_cast<int>(LOWORD(wParam)),static_cast<int>(HIWORD(wParam))) ? TRUE : FALSE;
		case WM_SIZE:		return target->OnSize(me,wParam,LOWORD(lParam),HIWORD(lParam)) ? TRUE : FALSE;
		default:			return target->OnOtherMessage(me,uMsg,wParam,lParam);
		}
	}else return 0;
}



}//namespace window
}//namespace ablib