#ifndef __ABLIB_WINDOW_BASEMODALDLG_H__
#define __ABLIB_WINDOW_BASEMODALDLG_H__

#include "window.h"
#include "dialog.h"
#include "subclasswnd.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{

/** ModalDialog̊{NXD
*/

/**
* [__CAONXDhēKOn***ĂD
* TuNXꍇCSubClassWndhNXAddSubClassŒǉĂD
*/
class BaseModalDlg{
public:
	BaseModalDlg(HINSTANCE appint) : m_appint(appint),m_window(NULL){}
	virtual ~BaseModalDlg(){delete m_window;}
	intptr_t Create(Wnd *parent,LPCTSTR id);
	intptr_t Create(Wnd *parent,WORD id){return Create(parent,MAKEINTRESOURCE(id));}
	Dialog *GetWindow() const{return m_window;};

private:
	Dialog *m_window;
	HINSTANCE m_appint;

	BOOL Atach(HWND hwnd){return ::SetProp(hwnd,_T("ABENORI_WINDOW_PROP"),(HANDLE)this);}
	HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORI_WINDOW_PROP"));}
	static INT_PTR CALLBACK sDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);

	struct SubClassData{
		SubClassData(SubClassDlg *s,int i) : subclass(s),id(i),hwnd(NULL){}
		SubClassData(SubClassDlg *s,HWND h) : subclass(s),hwnd(h),id(0){}
		SubClassData() : subclass(NULL),id(0),hwnd(NULL){}
		int id;
		SubClassDlg *subclass;
		HWND hwnd;
	};
	SmallVector<SubClassData> m_subclass;

protected:
	void AddSubClass(SubClassDlg *sub,int id);
	void AddSubClass(SubClassDlg *sub,HWND hwnd);

	/// _CAO
	virtual bool OnInitDialog(Dialog *wnd){return false;}
	/// I
	virtual bool OnClose(Dialog *wnd){wnd->Destroy(0);return false;}
	virtual bool OnDestroy(Dialog *wnd){return false;}
	/// R}h
	virtual bool OnCommand(Dialog *wnd,int id, intptr_t param){return false;}
	// TCYύX
	virtual bool OnSize(Dialog *wnd, intptr_t sw, intptr_t width, intptr_t height){return false;}
	
	/// ̑
	virtual INT_PTR OnOtherMessage(Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){return FALSE;}
	
	/// ׂẴbZ[WO
	virtual bool PreTranslateMessage(Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam,INT_PTR &rv){return false;}

};

}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_BASEMODALDLG_H__

