#ifndef __ABLIB_WINDOW_BASEWND_H__
#define __ABLIB_WINDOW_BASEWND_H__

#include "window.h"
#include "subclasswnd.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{

/** EBhE̊{IȂ̂̂݋lߍ񂾃NXDhĎgD
* KOnXĂDtrueԂ悤ɁD
*/
class BaseWnd{
public:
	BaseWnd(const TCHAR *wcn,DWORD style,HINSTANCE appint,bool stopmsgloop = false) : 
	  m_style(style),m_wclassname(wcn),m_appint(appint),m_stopmsgloop(stopmsgloop){m_window = NULL;}
	virtual ~BaseWnd();
	
	Window *Create(Wnd *parent,HCURSOR cursor = ::LoadCursor(NULL,IDC_IBEAM));

	const TCHAR *GetWindowClassName(){return m_wclassname.c_str();}

	Window *GetWindow() const{return m_window;}

protected:
	DWORD GetStyle() const{return m_style;}
	void SetStyle(DWORD style){m_style = style;}
	
private:
	BOOL Atach(HWND hwnd){return ::SetProp(hwnd,_T("ABENORI_WINDOW_PROP"),reinterpret_cast<HANDLE>(this));}
	HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORI_WINDOW_PROP"));}
	static LRESULT CALLBACK sWndProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);

	Window *m_window;
	DWORD m_style;
	ablib::string m_wclassname;
	bool m_stopmsgloop;
	HINSTANCE m_appint;

	// XN[wp[
	int CalcScroll(LONG type,UINT code);

	struct SubClassData{
		SubClassData(SubClassDlg *s,int i) : subclass(s),id(i),hwnd(NULL){}
		SubClassData(SubClassDlg *s,HWND h) : subclass(s),hwnd(h),id(0){}
		SubClassData() : subclass(NULL),id(0),hwnd(NULL){}
		int id;
		SubClassDlg *subclass;
		HWND hwnd;
	};
	SmallVector<SubClassData> m_subclass;

protected:
	void AddSubClass(SubClassDlg *sub,int id);
	void AddSubClass(SubClassDlg *sub,HWND hwnd);

	//eCxgD
	/// 
	virtual bool OnCreate(Window *wnd){return false;}
	/// j󎞁iĂȂĂ󂷎trueԂāIj
	virtual bool OnDestroy(Window *wnd){return true;}
	/// 
	virtual bool OnClose(Window *wnd){return false;}
	/// `
	virtual bool OnPaint(Window *wnd){return false;}
	/// TCYύX
	virtual bool OnSize(Window *wnd,intptr_t sw, intptr_t width, intptr_t height){return false;}
	/// tH[JX𓾂
	virtual bool OnSetFocus(Window *wnd,Window *old){return false;}
	/// tH[JXD
	virtual bool OnKillFocus(Window *wnd,Window *New){return false;}
	/// }EX
	virtual bool OnMouseMove(Window *wnd,Mouse *mos, intptr_t keyFlags){return false;}
	/// {^ꂽD
	virtual bool OnLButtonDown(Window *wnd,Mouse *mos,bool isDClick){return false;}
	/// {^
	virtual bool OnLButtonUp(Window *wnd,Mouse *mos){return false;}
	/// E{^ꂽ
	virtual bool OnRButtonDown(Window *wnd,Mouse *mos,bool isDClick){return false;}
	/// E{^
	virtual bool OnRButtonUp(Window *wnd,Mouse *mos){return false;}
	/// ^񒆃{^ꂽ
	virtual bool OnMButtonDown(Window *wnd,Mouse *mos,bool isDClick){return false;}
	/// ^񒆃{^
	virtual bool OnMButtonUp(Window *wnd,Mouse *mos){return false;}
	/// 肭
	virtual bool OnMouseWheel(Window *wnd,Mouse *mos, intptr_t delta, intptr_t key){return false;}
	/// L[ꂽ
	virtual bool OnKey(Window *wnd,bool isDown,UINT vk, intptr_t repeat){return false;}
	/// WM_CHAR
	virtual bool OnChar(Window *wnd,TCHAR ch, intptr_t repeat){return false;}
	/// IME͂ꂽD
	virtual bool OnIME(Window *wnd){return false;}
	/// XN[
	virtual bool OnHScroll(Window *wnd, intptr_t dx){return false;}
	virtual bool OnVScroll(Window *wnd, intptr_t dy){return false;}
	/// R}h
	virtual bool OnCommand(Window *wnd,int id, intptr_t param){return false;}
	virtual bool OnNotify(Window *wnd,NMHDR *nmhdr,LRESULT &rv){return false;}
	/// D&D
	virtual bool OnDropFiles(const std::vector<ablib::string> &files){return false;}
	
	virtual bool PreTranslateMessage(ablib::window::Window *wnd,UINT uMsg,WPARAM wParam,LPARAM lParam,LRESULT &rv){return false;}
};


}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_BASEWND_H__

