#ifndef __ABLIB_WINDOW_DIALOG_H__
#define __ABLIB_WINDOW_DIALOG_H__

#include "window.h"

namespace ablib{
namespace window{

/** e_CAȎɎg܂D
*/

/** _CAO̊NXD
* _CAOɋʂ郁\bhĉ낤ccH
*/
class Dialog : public Wnd{
public:
	Dialog(HWND hwnd) : Wnd(hwnd),m_font(NULL){}
	Dialog(Wnd *wnd) : Wnd(wnd->GetHWND()),m_font(NULL){}
	Dialog(Wnd *wnd, int id) : Wnd(::GetDlgItem(wnd->GetHWND(),id)),m_font(NULL){}
	virtual ~Dialog(){if(m_font)::DeleteObject(m_font);}
	void Destroy(int rv){::EndDialog(m_hwnd,rv);}
	bool SetFont(FontData f,bool redraw = true);
	FontData GetFont();
private:
	HFONT m_font;
	FontData m_fontdata;
	void GetFontData();
};

class CheckBox : public Dialog{
public:
	CheckBox(HWND hwnd) : Dialog(hwnd){}
	CheckBox(Wnd *wnd) : Dialog(wnd){}
	CheckBox(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{style_auto = BS_AUTOCHECKBOX,style_normal = BS_CHECKBOX};

	static bool Create(Wnd *parent,int id,const TCHAR *str,HINSTANCE appint,Rect rect = Rect(0,0,0,0),
		int style = WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX){
		return ::CreateWindow(_T("BUTTON"),str,style,
			(int)rect.left,(int)rect.top,(int)(rect.right - rect.left),(int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}
	void SetCheck(bool b){::SendMessage(m_hwnd,BM_SETCHECK,b ? BST_CHECKED : BST_UNCHECKED,0);}
	bool GetCheck(){return (::SendMessage(m_hwnd,BM_GETCHECK,0,0) == BST_CHECKED);}
};

class Edit : public Dialog{
public:
	Edit(HWND hwnd) : Dialog(hwnd){}
	Edit(Wnd *wnd) : Dialog(wnd){}
	Edit(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{
		style_multiline = ES_MULTILINE,style_hscroll = ES_AUTOHSCROLL,
		style_vscroll = ES_AUTOVSCROLL,style_left = ES_LEFT,style_right = ES_RIGHT,
		style_center = ES_CENTER
	};

	static bool Create(Wnd *parent,int id,HINSTANCE appint,Rect rect = Rect(0,0,0,0),
		int style =  WS_CHILD | WS_VISIBLE | ES_LEFT | ES_AUTOHSCROLL){
		return ::CreateWindow(_T("EDIT"),NULL,style,
			(int)rect.left,(int)rect.top,(int)(rect.right - rect.left),(int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}

	ablib::string GetText();
	void SetText(const ablib::string &text){::SetWindowText(m_hwnd,text.c_str());}
	void SetReadOnly(bool b){::SendMessage(m_hwnd,EM_SETREADONLY,b ? TRUE : FALSE,0);}
	
	void ToBottom(){::SendMessage(m_hwnd,EM_LINESCROLL,0,::SendMessage(m_hwnd,EM_GETLINECOUNT,0,0));}
	void SetSel(intptr_t from, intptr_t to){::SendMessage(m_hwnd,EM_SETSEL,from,to);}
	void Copy(){::SendMessage(m_hwnd,WM_COPY,0,0);}
	void Paste(){::SendMessage(m_hwnd,WM_PASTE,0,0);}
	void Cut(){::SendMessage(m_hwnd,WM_CUT,0,0);}
	void Undo(){::SendMessage(m_hwnd,WM_UNDO,0,0);}
};

inline ablib::string Edit::GetText(){
	TCHAR str[65536];
	::GetWindowText(m_hwnd,str,65535);
	ablib::string rv = str;
	return rv;
}

class Combo : public Dialog{
public:
	Combo(Wnd *wnd) : Dialog(wnd){}
	Combo(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{style_sort = CBS_SORT,style_simple = CBS_SIMPLE,
	style_dropdown = CBS_DROPDOWN};

	static bool Create(Wnd *parent,int id,HINSTANCE appint,Rect rect = Rect(0,0,0,0),
		int style = WS_VISIBLE | WS_CHILD | WS_BORDER | CBS_SIMPLE | CBS_DROPDOWN){
		return ::CreateWindow(_T("COMBOBOX"),NULL,style,
			(int)rect.left, (int)rect.top, (int)(rect.right - rect.left), (int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}

	bool AddString(const TCHAR *str){return (::SendMessage(m_hwnd,CB_ADDSTRING,0,reinterpret_cast<LPARAM>(str)) != CB_ERR);}
	bool AddString(const ablib::string &s){return AddString(s.c_str());}
	bool InsertString(int index,const TCHAR *str){return (::SendMessage(m_hwnd,CB_INSERTSTRING,index,reinterpret_cast<LPARAM>(str)) != CB_ERR);}
	bool InsertString(int index,const ablib::string &s){return InsertString(index,s.c_str());}
	void DeleteString(int index){::SendMessage(m_hwnd,CB_DELETESTRING,index,0);}
	void DeleteAllString(){::SendMessage(m_hwnd,CB_RESETCONTENT,0,0);}
	intptr_t GetCount(){return ::SendMessage(m_hwnd,CB_GETCOUNT,0,0);}
	intptr_t GetCurSel(){return ::SendMessage(m_hwnd,CB_GETCURSEL,0,0);}
	void SetCurSel(int index){::SendMessage(m_hwnd,CB_SETCURSEL,index,0);}
	void DropDown(bool d){::SendMessage(m_hwnd,CB_SHOWDROPDOWN,d ? TRUE : FALSE,0);}
	bool IsDropDown(){return ::SendMessage(m_hwnd,CB_GETDROPPEDSTATE,0,0) != FALSE;}
	ablib::string GetText();
	ablib::string GetText(int i);
	Edit GetEdit();
	void ShowDropDown(bool drop = true){::SendMessage(m_hwnd,CB_SHOWDROPDOWN,(LPARAM)(drop?TRUE:FALSE),0);}
};

inline ablib::string Combo::GetText(){
	int len = ::GetWindowTextLength(m_hwnd) + 10;
	TCHAR *str = new TCHAR[len + 1];
	::GetWindowText(m_hwnd,str,len);
	ablib::string rv = str;
	delete[] str;
	return rv;
}

inline ablib::string Combo::GetText(int index){
	TCHAR *str = new TCHAR[::SendMessage(m_hwnd,CB_GETLBTEXTLEN,index,0) + 10];
	::SendMessage(m_hwnd,CB_GETLBTEXT,index,reinterpret_cast<LPARAM>(str));
	ablib::string rv = str;
	delete[] str;
	return rv;
}

inline ablib::window::Edit Combo::GetEdit(){
	COMBOBOXINFO cbi;
	::ZeroMemory(&cbi,sizeof(COMBOBOXINFO));
	cbi.cbSize = sizeof(COMBOBOXINFO);
//	if(!::SendMessage(m_hwnd,CB_GETCOMBOBOXINFO,0,reinterpret_cast<LPARAM>(&cbi))){
	if(::GetComboBoxInfo(m_hwnd,&cbi)){
		return Edit(cbi.hwndItem);
	}else return Edit((HWND)NULL);
}


class StatusBar : public Dialog{
public:
	StatusBar(Wnd *wnd) : Dialog(wnd){}
	StatusBar(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{	style_bottom = CCS_BOTTOM,style_top = CCS_TOP,style_sizegrip = SBARS_SIZEGRIP};


	static bool Create(Wnd *parent,int id,int style = WS_VISIBLE | CCS_BOTTOM){
		return ::CreateStatusWindow(style | WS_CHILD,NULL,parent ? parent->GetHWND() : NULL,id) != NULL;
	}

	void SetParts(const std::vector<int> &parts){::SendMessage(m_hwnd,SB_SETPARTS,parts.size(),reinterpret_cast<LPARAM>(&parts[0]));}
	void SetText(int i,const TCHAR *str){::SendMessage(m_hwnd,SB_SETTEXT,i,reinterpret_cast<LPARAM>(str));}
};

class ToolBar : public Dialog{
public:
	ToolBar(Wnd *wnd) : Dialog(wnd){}
	ToolBar(Wnd *wnd,int id) : Dialog(wnd,id){}

	struct SysButton{
		SysButton(int b,int i) : button(b),id(i){}
		int button;
		int id;
	};

	static bool Create(Wnd *parent,int id,const std::vector<WORD> &ids,Point size,HINSTANCE appint,int style = WS_CHILD | WS_VISIBLE | WS_BORDER);
	static bool CreateSysToolBar(Wnd *parent,int id,const std::vector<SysButton> &ids,Point size,int style = WS_CHILD | WS_VISIBLE | WS_BORDER);
	void Add(const std::vector<WORD> &ids,int id,HINSTANCE appint);
	void AddSysToolBar(const std::vector<WORD> &ids){
		return Add(ids,IDB_STD_SMALL_COLOR,HINST_COMMCTRL);
	}
	void InsertSep(int i){
		TBBUTTON sep = {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0, 0};
		::SendMessage(m_hwnd,TB_INSERTBUTTON,i,reinterpret_cast<LPARAM>(&sep));
	}

	struct ToolTip{
		ToolTip(int b,int s) : buttonid(b),stringid(s){}
		int buttonid;
		int stringid;
	};
	void SetToolTip(const std::vector<ToolTip> &tips,HINSTANCE appint);

	void OnSize(int sw,int width,int height){::SendMessage(m_hwnd,WM_SIZE,sw,MAKELPARAM(width,height));}
	void AutoSize(){::SendMessage(m_hwnd,TB_AUTOSIZE,0,0);}

private:
	static TBBUTTON *CreateTBButton(const std::vector<WORD> &ids,int *num);
	static TBBUTTON *CreateTBButton(const std::vector<SysButton> &ids,int *num);

};

class List : public Dialog{
public:
	List(Wnd *wnd) : Dialog(wnd){}
	List(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{style_standard = LBS_STANDARD};

	static bool Create(Wnd *parent,int id,HINSTANCE appint,Rect rect = Rect(0,0,0,0),int style = WS_CHILD | LBS_STANDARD){
		return ::CreateWindow(_T("LISTBOX"),NULL,style,
			(int)rect.left, (int)rect.top, (int)(rect.right - rect.left), (int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}


	bool AddString(const TCHAR *str){return (::SendMessage(m_hwnd,LB_ADDSTRING,0,reinterpret_cast<LPARAM>(str)) != LB_ERR);}
	bool AddString(const ablib::string &str){return AddString(str.c_str());}
	bool InsertString(int index,const TCHAR *str){return (::SendMessage(m_hwnd,LB_INSERTSTRING,index,reinterpret_cast<LPARAM>(str)) != LB_ERR);}
	bool InsertString(int index,const ablib::string &str){return InsertString(index,str.c_str());}
	void DeleteString(int index){::SendMessage(m_hwnd,LB_DELETESTRING,index,0);}
	intptr_t GetCount(){return ::SendMessage(m_hwnd,LB_GETCOUNT,0,0);}
	intptr_t GetCurSel(){return ::SendMessage(m_hwnd,LB_GETCURSEL,0,0);}
	void SetCurSel(intptr_t n){::SendMessage(m_hwnd,LB_SETCURSEL,n,0);}
	bool IsSel(intptr_t n){return ::SendMessage(m_hwnd,LB_GETSEL,n,0) > 0;}
	ablib::string GetText(){return GetText(GetCurSel());}
	ablib::string GetText(intptr_t i);
	void Reset(){::SendMessage(m_hwnd,LB_RESETCONTENT,0,0);}
	void SetHorizontalExtent(int extent){::SendMessage(m_hwnd,LB_SETHORIZONTALEXTENT,(WPARAM)extent,0);}
	void SetHorizontalExtent();

};

inline ablib::string List::GetText(intptr_t index){
	TCHAR *str = new TCHAR[::SendMessage(m_hwnd,LB_GETTEXTLEN,index,0) + 10];
	::SendMessage(m_hwnd,LB_GETTEXT,index,reinterpret_cast<LPARAM>(str));
	ablib::string rv = str;
	delete[] str;
	return rv;
}

class StaticText : public Dialog{
public:

	static bool Create(Wnd *parent,const TCHAR *str,HINSTANCE appint,Rect rect = Rect(0,0,0,0),
		int style = WS_CHILD | WS_VISIBLE, int id = -1){
		return ::CreateWindow(_T("STATIC"),str,style,
			(int)rect.left, (int)rect.top, (int)(rect.right - rect.left), (int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}

	StaticText(Wnd *wnd) : Dialog(wnd){}
	StaticText(Wnd *wnd,int id) : Dialog(wnd,id){}
	void SetText(const TCHAR *str){::SetWindowText(m_hwnd,str);}
	void SetText(const ablib::string &str){SetText(str.c_str());}
};

// vOXo[
class ProgressBar : public Dialog{
public:
	ProgressBar(Wnd *wnd) : Dialog(wnd){}
	ProgressBar(Wnd *wnd,int id) : Dialog(wnd,id){}
	void SetRange(int r){::SendMessage(m_hwnd,PBM_SETRANGE,0,MAKELPARAM(0,r));}
	void SetStep(int s){::SendMessage(m_hwnd,PBM_SETSTEP,s,0);}
	void SetPos(int p){::SendMessage(m_hwnd,PBM_SETPOS,p,0);}

};

class Header : public Dialog{
public:
	Header(Wnd *wnd) : Dialog(wnd){}
	Header(Wnd *wnd,int id) : Dialog(wnd,id){}
	Header(HWND hwnd) : Dialog(hwnd){}
	int GetItemCount(){return Header_GetItemCount(m_hwnd);}
};

class ListView : public Dialog{
public:
	ListView(Wnd*wnd) : Dialog(wnd){}
	ListView(Wnd *wnd,int id) : Dialog(wnd,id){}

	enum style{style_icon = LVS_ICON,style_list = LVS_LIST,style_report = LVS_REPORT};

	static bool Create(Wnd *parent, int id,HINSTANCE appint,Rect rect = Rect(0,0,0,0),
		int style = WS_CHILD | WS_VISIBLE | LVS_REPORT){
		return ::CreateWindowEx(0,WC_LISTVIEW,0,style,
			(int)rect.left, (int)rect.top, (int)(rect.right - rect.left), (int)(rect.bottom - rect.top),
			parent ? parent->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id),appint,NULL) != NULL;
	}


	struct ColumnData{
		ColumnData(int w,const ablib::string &s) : width(w),str(s){}
		int width;
		ablib::string str;
	};

	int GetItemCount(){return ListView_GetItemCount(m_hwnd);}
	template<typename T> void AddItem(const T &data,bool check = false);
	void SetItemCount(int count){ListView_SetItemCount(m_hwnd,count);}
	bool GetCheckState(int index) const{return ListView_GetCheckState(m_hwnd,index) ? true : false;}
	std::vector<ablib::string> GetItem(int index);
	int GetCurSel(){return ListView_GetNextItem(m_hwnd,-1,LVNI_SELECTED);}
	void SetCurSel(int index){ListView_SetItemState(m_hwnd,index,LVIS_SELECTED,LVIS_SELECTED);}
	void SetColumn(const std::vector<ColumnData> &data);
	void SetColumn(int index,const ablib::string &str);
	void DeleteColumn(int index){ListView_DeleteColumn(m_hwnd,index);}
	int GetColumnCount(){return Header_GetItemCount(ListView_GetHeader(m_hwnd));}
	ColumnData GetColumn(int index);
	int GetColumnWidth(int index){return ListView_GetColumnWidth(m_hwnd,index);}
	void SetColumnWidth(int index,int width){ListView_SetColumnWidth(m_hwnd,index,width);}
	void DeleteAllItems(){ListView_DeleteAllItems(m_hwnd);}
	void SetCheckState(int index,bool b){ListView_SetCheckState(m_hwnd,index,b ? TRUE : FALSE);}
	
	int GetTopIndex(){return ListView_GetTopIndex(m_hwnd);}
	void Scroll(int dx,int dy = 0){	ListView_Scroll(m_hwnd,dx,dy);}
	Rect GetItemRect(int index,int code = LVIR_SELECTBOUNDS){RECT rc;ListView_GetItemRect(m_hwnd,index,&rc,code);return Rect(rc);}

	void EnableCheckBox(){ListView_SetExtendedListViewStyle(m_hwnd,LVS_EX_CHECKBOXES | ListView_GetExtendedListViewStyle(m_hwnd));}
	void EnableFullRowSelect(){ListView_SetExtendedListViewStyle(m_hwnd,LVS_EX_FULLROWSELECT | ListView_GetExtendedListViewStyle(m_hwnd));}
	void EnableGrid(){ListView_SetExtendedListViewStyle(m_hwnd,LVS_EX_GRIDLINES | ListView_GetExtendedListViewStyle(m_hwnd));}

	Header GetHeader(){return Header(ListView_GetHeader(m_hwnd));}
	
};

inline std::vector<ablib::string> ListView::GetItem(int index){
	std::vector<ablib::string> rv;
	int num = GetHeader().GetItemCount();
	LVITEM lvi;
	TCHAR str[4096];
	::ZeroMemory(&lvi,sizeof(LVITEM));
	lvi.mask = LVIF_TEXT | LVIF_DI_SETITEM;
	lvi.pszText = str;
	lvi.cchTextMax = 4095;
	lvi.iItem = index;
	for(int i = 0 ; i < num ; ++i){
		lvi.iSubItem = i;
		ListView_GetItem(m_hwnd,&lvi);
		rv.push_back(str);
	}
	return rv;
}

//inline void ListView::AddItem(const std::vector<ablib::string> &data,bool check){
template<typename T>  void ListView::AddItem(const T &data,bool check){
	if(data.empty())return;
	LVITEM lvi;
	::ZeroMemory(&lvi,sizeof(LVITEM));
	lvi.mask = LVIF_TEXT | LVIF_DI_SETITEM;
	lvi.iItem = GetItemCount();
	lvi.pszText = const_cast<TCHAR*>(data[0].c_str());
	lvi.cchTextMax = (int)data[0].length();
	lvi.iSubItem = 0;
	ListView_InsertItem(m_hwnd,&lvi);
	for(std::vector<ablib::string>::size_type i = 1 ; i < data.size() ; ++i){
		lvi.pszText = const_cast<TCHAR*>(data[i].c_str());
		lvi.cchTextMax = (int)data[i].length();
		lvi.iSubItem = (int)i;
		ListView_SetItem(m_hwnd,&lvi);
	}
	ListView_SetCheckState(m_hwnd,lvi.iItem,check ? TRUE : FALSE);
}



inline void ListView::SetColumn(const std::vector<ColumnData> &data){
	LVCOLUMN lvc;
	::ZeroMemory(&lvc,sizeof(LVCOLUMN));
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.fmt = LVCFMT_LEFT;
	for(std::vector<ColumnData>::size_type i = 0 ; i < data.size() ; ++i){
		lvc.cx = data[i].width;
		lvc.pszText = const_cast<TCHAR*>(data[i].str.c_str());
		lvc.cchTextMax = (int)data[i].str.length();
		lvc.iSubItem = (int)i;
		ListView_InsertColumn(m_hwnd,i,&lvc);
	}
}

inline void ListView::SetColumn(int index,const ablib::string &str){
	LVCOLUMN lvc;
	::ZeroMemory(&lvc,sizeof(LVCOLUMN));
	lvc.mask = LVCF_TEXT;lvc.pszText = const_cast<TCHAR*>(str.c_str());
	ListView_SetColumn(m_hwnd,index,&lvc);
}

inline ListView::ColumnData ListView::GetColumn(int index){
	TCHAR buf[4096];
	LVCOLUMN lvc;
	lvc.mask = LVCF_TEXT | LVCF_WIDTH;lvc.pszText = buf;lvc.cchTextMax = 4095;
	ColumnData cd(lvc.cx,lvc.pszText);
	return cd;
}

class ReBar : public Dialog{
public:
	ReBar(Wnd *wnd) : Dialog(wnd){}
	ReBar(Wnd *wnd,int id) : Dialog(wnd,id){}
	static bool Create(Wnd *parent,int id,HINSTANCE appint,
	int style = WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | RBS_BANDBORDERS | WS_CLIPCHILDREN | CCS_NODIVIDER);
	bool AddDlg(Dialog *dlg,const TCHAR *txt,Point size,int style = RBBS_CHILDEDGE);
	void OnSize(int sw,int width,int height){::SendMessage(m_hwnd,WM_SIZE,sw,MAKELPARAM(width,height));}

};

class TreeView : public Dialog{
public:
	TreeView(Wnd *wnd) : Dialog(wnd){}
	TreeView(Wnd *wnd,int id) : Dialog(wnd,id){}
	static bool Create(ablib::window::Wnd *wnd, int id,HINSTANCE appint,int style = TVS_SHOWSELALWAYS | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT | WS_VISIBLE | WS_CHILD){
		return ::CreateWindowEx(0, WC_TREEVIEW, _T(""), style,
			0, 0, 0,0, wnd ? wnd->GetHWND() : NULL, reinterpret_cast<HMENU>((intptr_t)id), appint, NULL) != NULL;
	}
	HTREEITEM GetSel(){return TreeView_GetSelection(m_hwnd);}
	enum expand_flag{
		collapse = TVE_COLLAPSE,
		collapsereset = TVE_COLLAPSERESET,
		expand = TVE_EXPAND,
		expandpartial = TVE_EXPANDPARTIAL,
		toggle = TVE_TOGGLE
	};

	struct Item{
		Item(const TCHAR *s,int image = -1) : str(s),imageindex(image){}
		Item() : imageindex(-1){}
		ablib::string str;
		int imageindex;
	};


	bool Expand(HTREEITEM item,expand_flag flag){return TreeView_Expand(m_hwnd,item,flag) != FALSE;}
	bool DeleteAll(){return TreeView_DeleteAllItems(m_hwnd) != FALSE;}
	bool Delete(HTREEITEM item){return TreeView_DeleteItem(m_hwnd,item) != FALSE;}
	HTREEITEM Insert(const Item &item,HTREEITEM parent = NULL,HTREEITEM after = TVI_LAST);
	bool Select(HTREEITEM item){return TreeView_Select(m_hwnd,item,TVGN_CARET) != FALSE;}
	bool SetImageList(HIMAGELIST himl,INT iImage = TVSIL_NORMAL){return ListView_SetImageList(m_hwnd,himl,iImage) != NULL;}
	
};

class Tab : public Dialog{
public:
	Tab(Wnd *wnd) : Dialog(wnd){}
	Tab(Wnd *wnd,int id) : Dialog(wnd,id){}
	static bool Create(ablib::window::Wnd *wnd, int id,HINSTANCE appint){
		return ::CreateWindowEx(0,WC_TABCONTROL,NULL,WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS,0,0,4,4,
			wnd ? wnd->GetHWND() : NULL,reinterpret_cast<HMENU>((intptr_t)id), appint, NULL) != NULL;
	}
	int AddItem(const TCHAR *label,int index,LPARAM lParam = 0){
		TC_ITEM item;item.mask = TCIF_TEXT;item.dwState = item.dwStateMask = 0;
		item.iImage = 0;item.lParam = lParam;item.pszText = const_cast<TCHAR*>(label);item.cchTextMax = ::lstrlen(label);
		return TabCtrl_InsertItem(m_hwnd,index,&item);
	}
	int AddItem(const ablib::string &label,int index,LPARAM lParam = 0){return AddItem(label.c_str(),index,lParam);}
	ablib::window::Rect AdjustRect(ablib::window::Rect rc){
		RECT r;r.left = (int)rc.left;r.right = (int)rc.right;r.top = (int)rc.top;r.bottom = (int)rc.bottom;
		TabCtrl_AdjustRect(m_hwnd,FALSE,&r);
		return ablib::window::Rect(r);
	}
	void DeleteItem(int index){TabCtrl_DeleteItem(m_hwnd,index);}
	int GetCurSel(){return TabCtrl_GetCurSel(m_hwnd);}
	void SetCurSel(int index){TabCtrl_SetCurSel(m_hwnd,index);}
};


}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_DIALOG_H__

