#ifndef __ABLIB_WINDOW_PROPSHEET_H__
#define __ABLIB_WINDOW_PROPSHEET_H__

#include <map>
#include "dialog.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{

/** WizardPropertySheet̓yłD
* ǵCBaseWizardTBasePropSheetpC
* XSheetWndpNXCقĂD
* AddSheetŊe_CAOǉCCreate΍܂D
*/
class PropSheet_Base{
public:
	PropSheet_Base(HINSTANCE appint) : m_appint(appint),m_sheet(NULL){}
	~PropSheet_Base(){delete m_sheet;}

	class Sheet : public Window{
	public:
		Sheet(HWND hwnd) : Window(hwnd){}
		bool SetCurSel(int index){return PropSheet_SetCurSel(GetHWND(),-1,index) != FALSE;}
		bool SetCurID(int id){return PropSheet_SetCurSelByID(GetHWND(),id) != FALSE;}
	};
	Sheet *GetWindow() const{return m_sheet;}

protected:
	template<typename T> bool Create(Window *parent,const TCHAR *title,const SmallVector<T> &sheets,DLGPROC proc,DWORD flag){
		HWND par = parent ? parent->GetHWND() : NULL;
		PROPSHEETPAGE psp;
		PROPSHEETHEADER psh;
		HPROPSHEETPAGE *hpsp = new HPROPSHEETPAGE[sheets.size()];
		
		::ZeroMemory(&psp,sizeof(PROPSHEETPAGE));
		psp.dwSize = sizeof(PROPSHEETPAGE);
		psp.dwFlags = PSP_DEFAULT;
		psp.hInstance = m_appint;
		psp.pfnDlgProc = proc;
		for(int i = 0 ; i < sheets.size() ; ++i){
			psp.pszTemplate = sheets[i]->m_id;
			psp.lParam = reinterpret_cast<LPARAM>(sheets[i]);
			hpsp[i] = ::CreatePropertySheetPage(&psp);
		}
		::ZeroMemory(&psh,sizeof(PROPSHEETHEADER));
		psh.dwSize = sizeof(PROPSHEETHEADER);
		psh.dwFlags = flag | PSH_USECALLBACK;
		psh.hwndParent = par;
		psh.pszCaption = title;
		psh.nPages = sheets.size();
		psh.phpage = hpsp;
		psh.pfnCallback = WndProc;
		// ATL/WTL̐^
		// R[obN֐Ăяoꂽm_dialog𐶐ׁC
		// uXbhIDthis|C^֘AÂD
		// Ipς݂Ȃ̂ŖD
		m_thread2pt[::GetCurrentThreadId()] = this;
		bool rv = ::PropertySheet(&psh) != -1;
		delete[] hpsp;
		delete m_sheet;
		m_sheet = NULL;
		return rv;
	}



private:
	static int CALLBACK WndProc(HWND hwndDlg,UINT uMsg,LPARAM lParam);
	BOOL Atach(HWND hwnd){return ::SetProp(hwnd,_T("ABENORIPROPSHEETPROP"),reinterpret_cast<HANDLE>(this));}
	HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORIPROPSHEETPROP"));}

	HINSTANCE m_appint;
	Sheet *m_sheet;

	static std::map<DWORD,PropSheet_Base*> m_thread2pt;

};

/** vpeBV[g̊NXD
*/
class BasePropSheet : protected PropSheet_Base{
public:
	class SheetWnd{
	public:
		SheetWnd(LPCTSTR id) : m_id(id){}
		SheetWnd(WORD id) : m_id(MAKEINTRESOURCE(id)){}
		virtual bool OnInitDialog(ablib::window::Dialog *wnd){return false;}
		virtual bool OnClose(ablib::window::Dialog *wnd){return false;}
		virtual bool OnDestroy(ablib::window::Dialog *wnd){return false;}
		virtual bool OnSetActive(ablib::window::Dialog *wnd){return false;}
		virtual bool OnCommand(ablib::window::Dialog *wnd,int id,int param){return false;}
		virtual bool OnApply(ablib::window::Dialog *wnd){return false;}
		virtual INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT Msg,WPARAM wParam,LPARAM lParam){return FALSE;}
		
	protected:
		BasePropSheet *GetParent() const{return m_parent;}

	private:
		BasePropSheet *m_parent;
		void InitParent(BasePropSheet *p){m_parent = p;}
		friend class BasePropSheet;
		friend class PropSheet_Base;
		LPCTSTR m_id;
	};

protected:
	BasePropSheet(HINSTANCE appint) : PropSheet_Base(appint){}
	bool CreatePropSheet(Window *parent,const TCHAR *title){return PropSheet_Base::Create(parent,title,m_sheets,SheetWndProc,PSH_DEFAULT);}
	void AddSheet(SheetWnd *s){s->InitParent(this);m_sheets.push_back(s);}
	void ClearSheet(){m_sheets.clear();}

private:
	SmallVector<SheetWnd*> m_sheets;
	
	static INT_PTR CALLBACK SheetWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static BOOL Atach(HWND hwnd,SheetWnd *d){return ::SetProp(hwnd,_T("ABENORIPROPSHEETPROP"),reinterpret_cast<HANDLE>(d));}
	static HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORIPROPSHEETPROP"));}
};

/** EBU[h
*/
class BaseWizard : protected PropSheet_Base{
protected:
	BaseWizard(HINSTANCE appint) : PropSheet_Base(appint){}

public:
	class SheetWnd{
	public:
		SheetWnd(bool next,bool back,bool finish,WORD id) : 
			m_next(next),m_back(back),m_finish(finish),m_id(MAKEINTRESOURCE(id)),
			m_window(NULL),m_parent(NULL){}
		SheetWnd(bool next,bool back,bool finish,LPCTSTR id) : 
			m_next(next),m_back(back),m_finish(finish),m_id(id),
			m_window(NULL),m_parent(NULL){}
		~SheetWnd(){delete m_window;}
		virtual bool OnInitDialog(ablib::window::Dialog *wnd){return false;}
		virtual bool OnClose(ablib::window::Dialog *wnd){return false;}
		virtual bool OnDestroy(ablib::window::Dialog *wnd){return false;}
		virtual bool OnCommand(ablib::window::Dialog *wnd,int id,int param){return false;}
		virtual LPCTSTR OnSetActive(ablib::window::Dialog *wnd){return false;}
		virtual LPCTSTR OnWizNext(ablib::window::Dialog *wnd){return false;}
		virtual LPCTSTR OnWizBack(ablib::window::Dialog *wnd){return false;}
		virtual bool OnWizFinish(ablib::window::Dialog *wnd){return false;}
		virtual INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT Msg,WPARAM wParam,LPARAM lParam){return FALSE;}
		Dialog *GetWindow(){return m_window;}

	protected:
		BaseWizard *GetParentPropSheet() const{return m_parent;}
		bool IsPreviousID(WORD id){return m_parent->m_previousid == MAKEINTRESOURCE(id);}
		bool IsPreviousID(LPCTSTR id){return m_parent->m_previousid == id;}
		void SetPreviousID(WORD id){m_parent->m_previousid = MAKEINTRESOURCE(id);}
		void SetPreviousID(LPCTSTR id){m_parent->m_previousid = id;}
		void SetPreviousID(){m_parent->m_previousid = m_id;}

	private:
		bool m_next,m_back,m_finish;
		LPCTSTR m_id;
		friend class BaseWizard;
		friend class PropSheet_Base;
		Dialog *m_window;

		BaseWizard *m_parent;
		void InitParent(BaseWizard *p){m_parent = p;}
	};
	typedef PropSheet_Base::Sheet Sheet;
	Sheet *GetWindow() const{return PropSheet_Base::GetWindow();}

protected:
	bool CreateWizard(Window *parent,const TCHAR *title){return PropSheet_Base::Create(parent,title,m_sheets,SheetWndProc,PSH_WIZARD);}
	void AddSheet(SheetWnd *s){s->InitParent(this);m_sheets.push_back(s);}
	void ClearSheet(){m_sheets.clear();}

private:
	SmallVector<SheetWnd*> m_sheets;
	LPCTSTR m_previousid;

	static INT_PTR CALLBACK SheetWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static BOOL Atach(HWND hwnd,SheetWnd *d){return ::SetProp(hwnd,_T("ABENORIPROPSHEETPROP"),reinterpret_cast<HANDLE>(d));}
	static HANDLE Detach(HWND hwnd){return ::RemoveProp(hwnd,_T("ABENORIPROPSHEETPROP"));}

	friend class SheetWnd;
};

}//namesapce window
}//namespace ablib


#endif //__ABLIB_WINDOW_PROPSHEET_H__

