#ifndef __ABLIB_WINDOW_WINDOW_H__
#define __ABLIB_WINDOW_WINDOW_H__

#include "ablib_window.h"
#include "../ablib/SmallVector.h"
#include <vector>

#ifndef TPM_NOANIMATION
#define TPM_NOANIMATION     0x4000L
#endif

namespace ablib{
namespace window{

/// ʏ̈ʒu\
struct Point{
	Point(intptr_t x1,intptr_t y1) : x(x1),y(y1){}
	Point() : x(0),y(0){}
	Point(const Point &obj) : x(obj.x),y(obj.y){}
	explicit Point(const POINT &pt) : x(pt.x),y(pt.y){}
	intptr_t x;intptr_t y;
	Point &operator+=(const Point &obj){x += obj.x;y += obj.y;return *this;}
};
inline const Point operator+(const Point &lhs,const Point &rhs){return Point(lhs) += rhs;}

/// TCY\
struct Size{
	Size(intptr_t w,intptr_t h) : width(w),height(h){}
	Size() : width(0),height(0){}
	Size(const Size &obj) : width(obj.width),height(obj.height){}
	intptr_t width; intptr_t height;
	Size &operator+=(const Size &obj){width += obj.width;height += obj.height;return *this;}
};
inline const Size operator+(const Size &lhs,const Size &rhs){return Size(lhs) += rhs;}

/// ͎lp`
struct Rect{
	Rect(intptr_t l, intptr_t t, intptr_t r, intptr_t b) : top(t),left(l),bottom(b),right(r){}
	Rect() : top(0),bottom(0),left(0),right(0){}
	explicit Rect(const RECT &rc) : top(rc.top),bottom(rc.bottom),left(rc.left),right(rc.right){}
	intptr_t top; intptr_t bottom; intptr_t left; intptr_t right;
};
///F
struct rgb{
	rgb(int r,int g,int b) : red(r),green(g),blue(b){}
	rgb() : red(0),green(0),blue(0){}
	int red;int green;int blue;
	explicit rgb(COLORREF col) : red(GetRValue(col)),green(GetGValue(col)),blue(GetBValue(col)){}
};
/// tHgɊւf[^
struct FontData{
	FontData(const TCHAR *name, intptr_t h, intptr_t wei = FW_NORMAL, intptr_t w = 0) : fontname(name),avewidth(w),height(h),weight(wei){}
	FontData(const ablib::string &name, intptr_t h, intptr_t wei = FW_NORMAL, intptr_t w = 0) : fontname(name),avewidth(w),height(h),weight(wei){}
	FontData(){}
	ablib::string fontname;
	intptr_t avewidth;
	intptr_t height;
	intptr_t weight;
};

/* SẴEBhE̊ƂȂD
*/
class Wnd{
public:
	Wnd(HWND hwnd) : m_hwnd(hwnd){}
	Wnd(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL){}
	HWND GetHWND() const{return m_hwnd;}
	Wnd *GetParent(){
		if (!m_parent)m_parent = new Wnd(::GetParent(m_hwnd));
		return m_parent;
	}
	Wnd *m_parent = NULL;

	/// ANeBu
	void SetActive(){::SetActiveWindow(m_hwnd);}
	void SetFocus(){::SetFocus(m_hwnd);}
	void SetForground(){::SetForegroundWindow(m_hwnd);}

	/// TCY擾
	Rect GetRect();
	Rect GetClientRect();
	Point GetScreenSize(){return Point(::GetSystemMetrics(SM_CXSCREEN),::GetSystemMetrics(SM_CYSCREEN));}
	Point ScreenToClient(const Point &pt);
	Point ClientToScreen(const Point &pt);

	/// bZ[W{bNX
	enum msgstyle{mb_ok,mb_okcancel,mb_retrycancel,mb_yesno,mb_yesnocancel};
	enum msgresult{id_ok,id_yes,id_no,id_cancel,id_failed};
	msgresult MsgBox(const TCHAR *msg,const TCHAR *title,msgstyle style = mb_ok);
	msgresult MsgBox(const ablib::string &msg,const ablib::string &title,msgstyle style = mb_ok){return MsgBox(msg.c_str(),title.c_str(),style);}

	/// ʈړ
	void Move(Point pt,Size size){::MoveWindow(m_hwnd,(int)pt.x,(int)pt.y,(int)size.width,(int)size.height,TRUE);}
	void Move(Rect rc){::MoveWindow(m_hwnd,(int)rc.left,(int)rc.top,(int)(rc.right - rc.left),(int)(rc.bottom - rc.top),TRUE);}
//	void SetPos(Point pt,Point size,Wnd *w = NULL){::SetWindowPos(m_hwnd,w ? w->GetHWND() : NULL,pt.x,pt.y,size.x,size.y,SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOCOPYBITS);}

	/// L
	void Enabled(bool b){::EnableWindow(m_hwnd,b ? TRUE : FALSE);}

	/// EBhE\D
	enum showstate{sw_show = SW_SHOW,sw_hide = SW_HIDE,sw_restore = SW_RESTORE,
		sw_minimize = SW_MINIMIZE,sw_maximize = SW_MAXIMIZE};
 	void ShowWindow(showstate state,bool noactive = false){
		int st = state;
		if(noactive){
			switch(st){
			case SW_SHOW:			st = SW_SHOWNA;			break;
			case SW_SHOWMINIMIZED:	st = SW_SHOWMINNOACTIVE;break;
			default:										break;
			}
		}
		::ShowWindow(m_hwnd,st);
		::UpdateWindow(m_hwnd);
	}
	showstate GetWindowState(){
		if(!::IsWindowVisible(m_hwnd))return sw_hide;
		else if(::IsIconic(m_hwnd))return sw_minimize;
		else if(::IsZoomed(m_hwnd))return sw_maximize;
		else return sw_show;
	}

	/// bZ[W֘A
	LRESULT SendCommand(int id, intptr_t param = 0){return ::SendMessage(m_hwnd,WM_COMMAND,MAKEWPARAM(id,param),0);}
/// łǂ邩l///////////////////////////////////////////////
	LRESULT SendMsg(UINT uMsg,WPARAM wParam,LPARAM lParam){return ::SendMessage(m_hwnd,uMsg,wParam,lParam);}

	/// eLXg֘AiHj
	ablib::string GetTitle();
	void SetTitle(const ablib::string &str){::SetWindowText(m_hwnd,str.c_str());}
	
	bool EnumChildWindows(std::vector<Wnd> &rv);

protected:
	static BOOL CALLBACK sEnumWindowsProc(HWND hwnd,LPARAM lParam);
	HWND m_hwnd;
};


inline Rect Wnd::GetClientRect(){
	RECT rc;
	::GetClientRect(m_hwnd,&rc);
	return Rect(rc.left,rc.top,rc.right,rc.bottom);
}

inline Rect Wnd::GetRect(){
	RECT rc;
	::GetWindowRect(m_hwnd,&rc);
	return Rect(rc.left,rc.top,rc.right,rc.bottom);
}

inline Point Wnd::ClientToScreen(const Point &pt){
	POINT p;p.x = (int)pt.x;p.y = (int)pt.y;
	::ClientToScreen(m_hwnd,&p);
	return Point(p);
}

inline Point Wnd::ScreenToClient(const Point &pt){
	POINT p;p.x = (LONG)pt.x;p.y = (LONG)pt.y;
	::ScreenToClient(m_hwnd,&p);
	return Point(p);
}

class Caret{
public:
	Caret(HWND hwnd) : m_hwnd(hwnd),m_iscreated(false){}
	Caret(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL),m_iscreated(false){}
	bool IsCreated() const{return m_iscreated;}
	void Create(intptr_t width, intptr_t height){::CreateCaret(m_hwnd,NULL,(int)width,(int)height);m_iscreated = true;}
	void Destroy(){::DestroyCaret();m_iscreated = false;}
	void SetPos(Point pt){::SetCaretPos((int)pt.x,(int)pt.y);}
	void Show(){::ShowCaret(m_hwnd);}
	void Hide(){::HideCaret(m_hwnd);}
	Point GetPos();
private:
	HWND m_hwnd;
	bool m_iscreated;
};

class IME{
public:
	IME(HWND hwnd) : m_hwnd(hwnd){}
	IME(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL){}
	void SetFont(FontData f);
	void SetPos(Point pt);
	bool GetText(::ablib::string &result);
	void SetOpen(bool b);
	bool IsOpen();
private:
	HWND m_hwnd;
};


class Mouse{
public:
	Mouse(HWND hwnd,Point pt = Point(0,0)) : m_hwnd(hwnd),m_pt(pt){}
	Mouse(Wnd *wnd,Point pt = Point(0,0)) : m_hwnd(wnd ? wnd->GetHWND() : NULL),m_pt(pt){}
	void SetCapture(){::SetCapture(m_hwnd);}
	void ReleaseCapture(){::ReleaseCapture();}
	Point GetPos(){return m_pt;}

private:
	HWND m_hwnd;
	Point m_pt;
};

class ScrollBar{
public:
	virtual void SetRange(intptr_t from, intptr_t to) = 0;
	virtual void SetPage(intptr_t page) = 0;
	virtual void SetPos(intptr_t pos) = 0;

	virtual intptr_t GetPos() = 0;
	virtual intptr_t GetPage() = 0;
	
	virtual void WindowScroll(intptr_t scroll) = 0;
};

template<bool isvert> class ScrollBarimpl : public ScrollBar{
public:
	ScrollBarimpl(HWND hwnd) : m_hwnd(hwnd){
		::ZeroMemory(&m_si,sizeof(SCROLLINFO));m_si.cbSize = sizeof(SCROLLINFO);
		m_si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE | SIF_TRACKPOS;
	}
	ScrollBarimpl(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL){
		::ZeroMemory(&m_si,sizeof(SCROLLINFO));m_si.cbSize = sizeof(SCROLLINFO);
		m_si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE | SIF_TRACKPOS;
	}
	void SetRange(intptr_t from, intptr_t to);
	void SetPage(intptr_t page);
	void SetPos(intptr_t pos);
	intptr_t GetPos(){return m_si.nPos;}
	intptr_t GetPage(){return m_si.nPage;}
	void WindowScroll(intptr_t scroll);

private:
	HWND m_hwnd;
	SCROLLINFO m_si;
};

typedef ScrollBarimpl<true>  HScrollBar;
typedef ScrollBarimpl<false> VScrollBar;

class Menu{
public:
	Menu(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL){}
	Menu(HWND hwnd) : m_hwnd(hwnd){}
	~Menu(){}
	enum posalign{pos_leftbottom,pos_lefttop,pos_rightbottom,pos_righttop};

	bool AddMenu(int parentid,int id,const TCHAR *str = _T(""));
	bool AddRootMenu(int id,const TCHAR *str);
	bool DeleteMenu(int id){return m_menuitem.DeleteMenu(id);}
	bool CreateWindowMenu();
	int CreatePopupMenu(Point pt,posalign pos = pos_lefttop);
	void Clear(){m_menuitem.Clear();}
	void Enabled(bool b){::EnableWindow(m_hwnd,b ? TRUE : FALSE);}
	bool SetDefaultMenu(int id);
	

private:
	void Destroy(HMENU menu);
	class MenuItem{
	public:
		MenuItem(){};
		~MenuItem();
		void AddMenu(int id,const TCHAR *str){m_data.push_back(MenuData(id,str));}
		bool AddSubMenu(MenuItem *mi,int parentid);
		bool DeleteMenu(int id);
		void CreateMenu(HMENU hmenu,int defmenuid);
		MenuItem *GetMenuItemFromID(int id);
		bool IsExistID(int id);
		void Clear();

	private:
		struct MenuData{
			MenuData(int i,const TCHAR *s) : id(i),str(s),menu(NULL){}
			MenuData(){}
			ablib::string str;
			int id;
			MenuItem *menu;
		};
		SmallVector<MenuData> m_data;
	};

	MenuItem m_menuitem;
	HWND m_hwnd;
	int m_defmenuid;
};


/**
* HWND̑D
* 撣ɂ܂ȂĂȂD
*/
class Window : public Wnd{
public:
	explicit Window(HWND hwnd);
	Window(Wnd *wnd);
	~Window(){}
	/// `ׂʒu̎擾
	Rect GetPaintRect();
	/// eLXg̐F̐ݒD
	void SetTextColor(rgb c,rgb back){m_textcolor = c;m_backcolor = back;}
	rgb GetTextColor() const{return m_textcolor;}
	rgb GetBackgroundColor() const{return m_backcolor;}
	
	/// ̌
	enum linetype{ps_solid = PS_SOLID,ps_dot = PS_DOT,ps_dash = PS_DASH};
	void SetLineStyle(rgb c, intptr_t width,linetype typ){m_linecolor = c;m_linewidth = width;m_linetype = typ;}
	rgb GetLineColor() const{return m_linecolor;}
	linetype GetLineType() const{return m_linetype;}
	intptr_t GetLineWidth() const{return m_linewidth;}

	/// hԂ̐F
	void SetFillColor(rgb c){m_fillcolor = c;}
	rgb GetFillColor() const{return m_fillcolor;}
	
 	/// ʖ
	void Invalidate(Rect r);
	void Invalidate(){::InvalidateRect(m_hwnd,NULL,FALSE);}//S

	/// ʈړ
	void ScrollWindow(intptr_t x, intptr_t y);

	/// tHgݒ
	void SetFont(FontData f);
	/// tHg
	FontData GetFontData() const{return m_fontdata;}
	Size GetTextExtent(const TCHAR *s,size_t len);
	Size GetTextExtent(const ablib::string &s,size_t len){return GetTextExtent(s.c_str(),len);}
	Size GetTextExtent(const TCHAR *s){return GetTextExtent(s,::lstrlen(s));}
	Size GetTextExtent(const ablib::string &s){return GetTextExtent(s,s.length());}

	/// j
	void Destroy(){::DestroyWindow(m_hwnd);}
	
	/// caret
	Caret *GetCaret(){return &m_caret;}
	
	/// IME
	IME *GetIME(){return &m_ime;}

	/// j[
	Menu *GetMenu(){return &m_menu;}

	/// XN[o[
	ScrollBar *GetVScrollBar(){return &m_vscroll;}
	ScrollBar *GetHScrollBar(){return &m_hscroll;}

	/// D&DL
	void EnableDandD(bool b){::DragAcceptFiles(m_hwnd,b ? TRUE : FALSE);}

	void Update(){::UpdateWindow(m_hwnd);}
private:
	TEXTMETRIC m_textmetric;
	FontData m_fontdata;
	intptr_t m_linewidth;
	rgb m_textcolor,m_backcolor,m_linecolor,m_fillcolor;
	linetype m_linetype;

	Caret m_caret;
	IME m_ime;
	ScrollBarimpl<true> m_vscroll;
	ScrollBarimpl<false> m_hscroll;
	Menu m_menu;

	friend class Graphic;
	HDC m_hdc_from_graphic;
};

/** R_CAO
*/
class CommonDlg{
public:
	CommonDlg(HWND hwnd) : m_hwnd(hwnd){}
	CommonDlg(Wnd *wnd) : m_hwnd(wnd ? wnd->GetHWND() : NULL){}
	bool SelectDir(ablib::string &rv,const TCHAR *title,const TCHAR *def);
	bool OpenFileDlg(ablib::string &rv,const TCHAR *filter,const TCHAR *title,const TCHAR *def);
	bool SaveFileDlg(ablib::string &rv,const TCHAR *filter,const TCHAR *title,const TCHAR *def);

private:
	HWND m_hwnd;
	static int CALLBACK SelectDirProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM data);
	
};
/** Nbv{[h
*/
class ClipBoard{
public:
	ClipBoard(Window *wnd) : m_isopen(::OpenClipboard(wnd ? wnd->GetHWND() : NULL) ? true : false){}
	~ClipBoard(){::CloseClipboard();}
	bool SetText(const TCHAR *str,size_t len);
	bool SetText(const TCHAR *str){return SetText(str,::lstrlen(str));}
	bool SetText(const ablib::string &str){return SetText(str.c_str(),str.length());}
	// GNXv[́uRs[vƓD
	bool SetFile(const ablib::string &f){return SetFile(std::vector<ablib::string>(1,f));}
	bool SetFile(const std::vector<ablib::string> &files);
	bool GetText(::ablib::string &str);
	bool IsOpen() const{return m_isopen;}
private:
	bool m_isopen;
};

}//namesapce window
}//namespace ablib

#endif //__ABLIB_WINDOW_WINDOW_H__

